{***************************************************************************}
{**              S u p e r   V G A   verze 1.4                            **}
{**                (C) Seven Software 1998                                **}
{** Pres 150 procedur a funkci pro:                                       **}
{**           vytvareni grafiky v modu 320x200 az 1024x768 s 256 barvami **}
{**           podpora PCX souboru                                        **}
{**           praci s mysi a kurzoru i v 256 barvach                     **}
{**           praci s klavesnici                                         **}
{**           pouzivani XMS (bouhuzel neni v Protected Modu)             **}
{**           komprese a dekomprese souboru                              **}
{**           jednoduche rutiny pro PC Speaker                           **}
{***************************************************************************}
{$M 16384,0,655360}
{$F+}
unit svga;
interface
const mode320x200=1;
      mode640x350=2;
      mode640x400=3;
      mode640x480=4;
      mode800x600=5;
      mode1024x768=6;
const msipka=1;
      mkrizek=2;
      mkrizekx=3;
      mhodiny=4;
      mhodinyi=5;
      mpresipacky=6;
      motaznik=7;
      mruka=8;
      mok=9;
      mno=10;
      msipkaSZxJV=11;
      msipkaSxJ=12;
const mvMaster           = 0;
      mvVoice            = 1;
      mvFM               = 2;
      mvLine             = 3;
      mvMicrophone       = 4;
      mvSpeaker          = 5;
      mvCD               = 6;
const USEET4000      : BOOLEAN = FALSE;
      SEGP           : WORD = $3CD;
type  PaletteType=array[0..255,1..3] of byte;
      CharType=array[0..15] of byte;
      FontType=array[0..255] of chartype;
      Char8x8Type=array[0..7] of byte;
      Font8x8Type=array[0..255] of char8x8type;
      BWtype=(black,white);
      CurseType=(ToUp,ToDown,ToLeft,ToRight);
      TextOrientationType=(Horizontal,Vertical);
      WriteModeType=(normalmode,andmode,ormode,xormode);
      PCXInfoType=record
                   ver,comp:byte;
                   x,y:word;
                   palette:PaletteType;
                  end;
      XFileType=record
                  handle:word;
                  pozition,
                  size:longint;
                end;
type VADDR = RECORD
        A    : WORD;
        S    : BYTE;
        DUM  : BYTE;
     END;
var   TextOrientation:TextOrientationType;
      WriteMode:WriteModeType;
      NoColor:boolean;
      XMSerror:byte;
      SVGAerror:byte;
      IOWarring:boolean;
      XMSWarring:boolean;
      XMSInfo:record
                     locks,freehandle:byte;
                     length:word;
                     blockseg,blockofs:word;
                    end;
      drawpage:byte;
var Sb_io_port,SbVersion:word;
    SbProDetected,Sb16Detected:boolean;
    va:longint;
    V     : VADDR ABSOLUTE VA;
    AS    : BYTE;

procedure initgraph(mode:byte);
procedure closegraph;
function  IsVGA:boolean;
function  getgraphmode:byte;
procedure screen(page:byte);
function  getscreen:byte;
procedure drawto(page:byte);
procedure putpixel(x,y:word;color:byte);
function  getpixel(x,y:word):byte;
function  GetImage(x1,y1,x2,y2:integer):pointer;
procedure PutImage(x,y:integer;p:pointer);
procedure fadeto(fade:BWtype);
procedure scrollscreen(x,y,x1,y1:word;c:cursetype;preklop:boolean);
procedure clearscreen;
procedure fillscreen(color:byte);
procedure rectangle(x,y,x1,y1:word;color1:byte);
procedure bar(x,y,x1,y1:word;color2:byte);
{procedure circle(x,y,p:word;color1:byte);}
Procedure Circle(x,y,r:integer;c:byte);
Procedure Ellipse(x,y,r1,r2:integer;col:byte);
{procedure ellipse(x,y,x0,y0:word;color1:byte);}
Procedure Line (X, Y, X2, Y2 : integer; Color : Byte);
procedure setborder(b:byte);
function  getborder:byte;
procedure setpalette(paleta:palettetype;prvni,posledni:byte);
procedure loadpalette1(prvni,posledni:byte);
procedure loadpalette2(prvni,posledni:byte);
procedure loaddefaulpalette(prvni,posledni:byte);
procedure rollpalette(odb,dob:byte;kam:cursetype);
Procedure LoadTga(name:string);
procedure loadPCXfile(xx,yy:word;s:string);
procedure PCXfileinfo(s:string;var inf:PCXinfotype);
procedure putCUTfilecut(vx,vy,x1,y1,x2,y2:word;s:string);
procedure putCUTfile(vx,vy:word;s:string);
procedure putCUTfileF(vx,vy:word;off:longint;s:string);
procedure getpicture(x,y,x1,y1,se,off:word);
procedure putpicture(vx,vy:word;p:pointer);
procedure putpicturecut(vx,vy,zx,zy:word;se:word;off:word);
procedure putresizedCUT(x,y,newxsize,newysize,se,off:word);
procedure xputpicture(vx,vy:word;xms:xfiletype;start:longint);
procedure xputpicturecut(vx,vy,x1,y1,x2,y2:word;xms:xfiletype);
procedure copypage(fp,dp:byte);
procedure copypagecut(fp,vvx1,vvy1,vvx2,vvy2,dp,dx,dy:word);
procedure OutText(x,y:word;s:string;c:byte;p:pointer);
procedure OutText8x16(x,y:word;s:string;c:byte);
procedure OutText8x8(x,y:word;s:string;c:byte);
procedure outtext6x6(x,y:word;s:string;c:byte);
procedure fill(x,y:word;c:byte);
function  getmaxx:word;
function  getmaxy:word;
procedure setviewport(x1,y1,x2,y2:word);
procedure showmouse;
procedure hidemouse;
procedure redrawmouse;
procedure setmouse(x,y:word);
procedure setnewmcurzor(hsx,hsy:word;var c);
procedure setnewmcurzor256(hsx,hsy:word;var c);
procedure setmcurzor(ktery:byte);
procedure setmouseminmax(mnx,mxx,mny,mxy:word);
procedure setmousesinsitive(x,y:word);
procedure getrelmouse(var x,y:integer);
procedure setmouseevent(mask:byte;se,off:word);
procedure mousestatus(var x,y:word;var tl1,tl2,tl3:boolean);
procedure mousepoz(var x,y:word);
procedure joystickAinfo(var x,y:word;var tl1,tl2:boolean);
procedure joystickBinfo(var x,y:word;var tl1,tl2:boolean);
function  XMSerrmesage(err:byte):string;
function  testXMS:boolean;
function  XMSver:word;
procedure allocHMA(size:word);
procedure deallocHMA;
procedure GlobEnableA20;
procedure GlobDisableA20;
procedure LocalEnableA20;
procedure LocalDisableA20;
function  getA20status:boolean;
function  XMSmaxblock:word;
function  XMSfree:word;
function  allocXMS(size:word):word;
procedure deallocXMS(handle:word);
procedure moveXMS(SHandle,SSeg,SOfs,DHandle,DSeg,DOfs:word;Length:longint);
procedure BasetoXMS(SSeg,SOfs,DHandle:word;Length:longint);
procedure XMStoBase(SHandle,DSeg,DOfs:word;Length:longint);
procedure XMStoXMS(SHandle,DHandle:word;Length:longint);
procedure XMSblockinfo(handle:word);
procedure reallocXMS(handle,length:word);
procedure LockXMS(handle:word);
procedure unLockXMS(handle:word);
procedure allocUMB(size:word);
procedure deallocUMB(blockseg:word);
function  UMBmaxblock:word;
procedure XAssign(var f:XFileType;size:word);
procedure XRead(var f:XFileType;dest:pointer;size:longint);
procedure XWrite(var f:XFileType;dest:pointer;size:longint);
procedure XSeek(var f:XFileType;poz:longint);
function  XSize(var f:XFileType):longint;
function  XPoz(var f:XFileType):longint;
procedure XClose(var f:XFileType);
function  readkey:char;
function  keypressed:boolean;
function  testkey(ch:char):boolean;
procedure sentkey(ch:char);
function  compressfile(s,s1:string):integer;
function  decompressfile(s,s1:string):integer;
procedure playsound(vz,dz:integer);
procedure play(Pseg,Pofs,Ple:word);
function  geterrormesage(err:byte):string;
function  getSVGAmesage(err:byte):string;
function  SbReadByte:byte;
procedure SbWriteByte(b:byte);
function  SbReadMixerReg(reg:byte):byte;
procedure SbWriteMixerReg(reg,val:byte);
procedure SbGetDSPVersion;
function  SbDetect:boolean;
procedure SbMixerGetVolume(reg:byte;var VolLeft, VolRight:byte);
function  SbGetIRQ:integer;
PROCEDURE SETSEG(NR:BYTE);
procedure space;
procedure scify;
procedure normal;
procedure fun;
procedure scri;
implementation

uses crt,dos;
{$F+}
procedure space;external;
{$L SPACE}
procedure scify;external;
{$L SCIFY}
procedure normal;external;
{$L NORMAL}
procedure fun;external;
{$L FUN}
procedure scri;external;
{$L SCRI}
procedure font8x8;external;
{$L 8x8}

procedure longcall(addr: longint; var regs: registers); external;
{$L INFOPLUS}
{$F-}
var OrigMode,i,l: Integer;maxx,maxy:word;vx1,vy1,vx2,vy2:word;font:byte;r:registers;
    XMSaddr:longint;XMSex,InGraph:boolean;SaveExitProc:pointer;
    mousx,mousy:word;mt1,mt2,mt3,ready:boolean;lastm:writemodetype;oldvec08:procedure;
    was_cut:BOOLEAN;
    left_cut,
    right_cut,
    top_cut,
    bottom_cut:WORD;
VAR Steigung:BYTE;
    DY_mal2,DY_m_DX_mal2:INTEGER;
const linesize=320 div 4;
const startvirtualx=0;
      startvirtualy=0;
      xmax=319;
      ymax=199;
      XWID    : WORD = 320;
      YWID    : WORD = 200;
type  g_kurzor = array [ 0 .. 1, 0 .. 15 ] of word;
var   showm:boolean;curzm:g_kurzor;savm:array[0..15,0..15] of byte;smx,smy:word;
      mct256,mco:boolean;curzm256:array [ 0 .. 15, 0 .. 15 ] of byte;
Type Virtual  = Array [1..64000] of byte; { The size of our Virtual Screen }
     VirPoint = ^Virtual;                 { Pointer to the virtual screen }
Var Virscr: VirPoint;                     { The actual virtual screen }
    Viaddr : Word;                         { Segment of our virtual screen }
Procedure SetMemory;                      { Allocates memory }
Begin
  GetMem(VirScr,64000);
  Viaddr := Seg(Virscr^);
End;
Procedure FreeMemory;                     { Frees the memory }
Begin
  FreeMem(VirScr,64000);
End;

{$I d:\bp\pas\svgadata.pas}
PROCEDURE SETSEG(NR:BYTE);
BEGIN
  AS := NR;
  IF USEET4000 THEN BEGIN
    PORT[SEGP] := (NR SHL 4) + NR;
  END ELSE BEGIN
    PORT[SEGP] := (NR * 9) OR $40;
  END;
END;
function GetPixelX(x,y:word):byte; assembler;
asm
 XOR AL,AL
 MOV DI,y
 SUB DI,vy1
 JS @offscrn
 CMP DI,vy2
 JG @offscrn
 MOV BX,x
 SUB BX,vx1
 JS @offscrn
 CMP BX,vx2
 JG @offscrn
 SHL DI,1
 MOV DI,CS:[OFFSET gadr + DI]
 MOV AX,BX
 SHR AX,1
 SHR AX,1
 ADD DI,AX
 AND BX,3
 MOV AL,4
 MOV AH,BL
 MOV BL,drawpage
 AND BX,3
 SHL BX,1
 ADD BX,OFFSET Segment_Adr-StartIndex*2
 MOV ES,[BX]
 CLI
 MOV DX,3CEh
 OUT DX,AX
 MOV AL,ES:[DI]
 STI
@offscrn:
end;

procedure PutPixelX(x,y:word;color:byte); assembler;
asm
 MOV DI,y
 SUB DI,vy1
 JS @offscrn
 CMP DI,vy2
 JG @offscrn
 MOV BX,x
 SUB BX,vx1
 JS @offscrn
 CMP BX,vx2
 JG @offscrn
 SHL DI,1
 MOV DI,CS:[OFFSET gadr + DI]
 MOV AX,BX
 SHR AX,1
 SHR AX,1
 ADD DI,AX
 AND BX,3
 MOV AH,[OFFSET TranslateTab + BX]
 MOV AL,2
 MOV DX,3C4h
 MOV BL,drawpage
 SHL BX,1
 ADD BX,OFFSET Segment_Adr+StartIndex*2
 MOV ES,[BX]
 CLI
 OUT DX,AX
 MOV AL,color
 STOSB
 STI
@offscrn:
end;
FUNCTION QGETPIXEL(X,Y:WORD):BYTE;
BEGIN
  INLINE($A1/XWID/     {     MOV AX,[XWID] }
         $8B/$9E/Y/    {     MOV BX,[BP+Y] }
         $F7/$E3/      {     MUL BX        }
         $03/$86/X/    {     ADD AX,[BP+X] }
         $73/$01/      {     JNC L1        }
         $42/          { L1: INC DX        }
         $A3/VA/       {     MOV [VA],AX   }
         $89/$16/VA+2  {     MOV [VA+2],DX }
        );
  IF V.S <> AS THEN SETSEG(V.S);
  INLINE($B8/$A000/    { MOV AX,A000       }
         $8E/$C0/      { MOV ES,AX         }
         $8B/$3E/VA/   { MOV DI,[VA]       }
         $26/$8A/$05/  { MOV AL,ES:[DI]    }
         $88/$46/$FF   { MOV [BP-1],AL     }
        );
END; { GETPIXEL }


PROCEDURE QPUTPIXEL(X,Y:WORD;FARBE:BYTE);
BEGIN
  INLINE($A1/XWID/     {     MOV AX,[XWID] }
         $8B/$9E/Y/    {     MOV BX,[BP+Y] }
         $F7/$E3/      {     MUL BX        }
         $03/$86/X/    {     ADD AX,[BP+X] }
         $73/$01/      {     JNC L1        }
         $42/          { L1: INC DX        }
         $A3/VA/       {     MOV [VA],AX   }
         $89/$16/VA+2  {     MOV [VA+2],DX }
        );
  IF V.S <> AS THEN SETSEG(V.S);
  INLINE($B8/$A000/    { MOV AX,A000       }
         $8E/$C0/      { MOV ES,AX         }
         $8B/$3E/VA/   { MOV DI,[VA]       }
         $8A/$86/FARBE/{ MOV AL,[BP+FARBE] }
         $26/$88/$05   { MOV ES:[DI],AL    }
        );
END; { PLOT }
function  GetPixel(x,y:word):byte;
begin
 if (maxx=319) and (maxy=199) then getpixel:=getpixelx(x,y) else getpixel:=qgetpixel(x,y);
end;
procedure PutPixel(x,y:word;color:byte);
begin
 if (maxx=319) and (maxy=199) then
 begin
  case writemode of
   normalmode:putpixelX(x,y,color);
   andmode   :putpixelX(x,y,getpixelx(x,y) and color);
   ormode    :putpixelX(x,y,getpixelx(x,y) or color);
   xormode   :putpixelX(x,y,getpixelx(x,y) xor color);
  end;
 end else
 begin
  case writemode of
   normalmode:qputpixel(x,y,color);
   andmode   :qputpixel(x,y,qgetpixel(x,y) and color);
   ormode    :qputpixel(x,y,qgetpixel(x,y) or color);
   xormode   :qputpixel(x,y,qgetpixel(x,y) xor color);
  end;
 end;
end;
{$F+}
function getbite(cislo,bit:byte):byte;
var x:array[1..8] of byte;l,i:byte;
begin
 l:=cislo;for i:=8 downto 1 do
 begin
  x[i]:=l mod 2;
  l:=l div 2;
 end;getbite:=x[bit];
end;
procedure INT08; interrupt;
var i,l:byte;
begin
 inline($9C);
 oldvec08;
 if (ready=true) and (showm=true) then
 begin
  ready:=false;
  lastm:=writemode;
  writemode:=normalmode;
  mousepoz(mousx,mousy);
  if (smx<>mousx) or (smy<>mousy) or (mco=true) then
  begin
  if showm=true then
  begin
   mco:=false;
   for i:=0 to 15 do for l:=0 to 15 do putpixel(smx+i,smy+l,savm[i,l]);
   for i:=0 to 15 do for l:=0 to 15 do savm[i,l]:=getpixel(mousx+i,mousy+l);
   if mct256=true then
   begin
    for i:=0 to 15 do for l:=0 to 15 do if curzm256[i,l]<>0 then putpixel(mousx+i,mousy+l,curzm256[i,l]);
   end else
   begin
    for i:=0 to 15 do
    begin
    for l:=1 to 8 do
    begin
     if (getbite(lo(curzm[0,i]),l)=0) and (getbite(lo(curzm[1,i]),l)=0) then putpixel(mousx+l+7,mousy+i,0);
     if (getbite(lo(curzm[0,i]),l)=0) and (getbite(lo(curzm[1,i]),l)=1) then putpixel(mousx+l+7,mousy+i,15);
     if (getbite(lo(curzm[0,i]),l)=1) and (getbite(lo(curzm[1,i]),l)=1) then
     begin
      writemode:=xormode;
      putpixel(mousx+l+7,mousy+i,255);
      writemode:=normalmode;
     end;
   end;
   for l:=1 to 8 do
   begin
    if (getbite(hi(curzm[0,i]),l)=0) and (getbite(hi(curzm[1,i]),l)=0) then putpixel(mousx+l-1,mousy+i,0);
    if (getbite(hi(curzm[0,i]),l)=0) and (getbite(hi(curzm[1,i]),l)=1) then putpixel(mousx+l-1,mousy+i,15);
    if (getbite(hi(curzm[0,i]),l)=1) and (getbite(hi(curzm[1,i]),l)=1) then
    begin
     writemode:=xormode;
     putpixel(mousx+l-1,mousy+i,255);
     writemode:=normalmode;
    end;
   end;
  end;
  end;
  end;
 end;
  smx:=mousx;smy:=mousy;
  writemode:=lastm;
  ready:=true;
end;
end;
{$F-}
function IsVGA:boolean;
var Regs:registers;
begin
 with Regs do
  begin
   AX:=$1A00;
   Intr($10,Regs);
   IsVGA:=(AL=$1A) AND
          ((BL=7) OR (BL=8))
  end;
end;
PROCEDURE VSYNCH;
INLINE($BA/$3DA/  {        MOV  DX,3DAH }
       $EC/       { LOOP1: IN   AL,DX   }
       $A8/8/     {        TEST AL,8    }
       $75/$FB/   {        JNZ  LOOP1   }
       $EC/       { LOOP2: IN   AL,DX   }
       $A8/8/     {        TEST AL,8    }
       $74/$FB    {        JZ   LOOP2   }
      );
PROCEDURE HSYNCH;
INLINE($BA/$3DA/  {        MOV  DX,3DAH }
       $EC/       { LOOP1: IN   AL,DX   }
       $A8/1/     {        TEST AL,1    }
       $75/$FB/   {        JNZ  LOOP1   }
       $EC/       { LOOP2: IN   AL,DX   }
       $A8/1/     {        TEST AL,1    }
       $74/$FB    {        JZ   LOOP2   }
      );
FUNCTION  CHECKVGA(MODE:BYTE):INTEGER;
VAR   V  : BYTE ABSOLUTE $A000:$FFFF;
      I  : BYTE;
      R  : REGISTERS;

FUNCTION CHECKSEG(ANZ:BYTE):BOOLEAN;
VAR   B  : BYTE;
BEGIN
  CHECKSEG := FALSE;
  FOR B := 0 TO ANZ DO BEGIN
    SETSEG(B);
    V := B;
  END; { NEXT B }
  FOR B := 0 TO ANZ DO BEGIN
    SETSEG(B);
    IF V <> B THEN EXIT;
  END; { NEXT B }
  CHECKSEG := TRUE;
END; { CHECKSEG }

BEGIN { CHECKVGA }
  CHECKVGA := -1;
  XWID:=MAXX+1;YWID:=MAXY+1;
  VSYNCH;
  R.AL := MODE; { VIDEOMODUS }
  R.AH := $00;
  INTR($10,R);  { SETZEN }

  CHECKVGA := -2;
  SETSEG(1);
  V := $33;
  IF V <> $33 THEN BEGIN
    V := 0;
    USEET4000 := TRUE;
    SETSEG(1);
    V := $33;
    IF V <> $33 THEN EXIT;
  END;
  V := $AA;
  IF V <> $AA THEN EXIT;

  IF NOT CHECKSEG(3) THEN CHECKVGA := 0 ELSE
    IF NOT CHECKSEG(7) THEN CHECKVGA := 4 ELSE
      IF NOT CHECKSEG(15) THEN CHECKVGA := 8 ELSE
        CHECKVGA := 16;

  FOR I := 0 TO 15 DO BEGIN
    SETSEG(I);
    V := 0;
  END;
  XWID:=MAXX+1;YWID:=MAXY+1;
  SETSEG(0);
END; { CHECKVGA }
PROCEDURE RAMTOVGA(VON:POINTER;BIS:LONGINT;WID:WORD);
TYPE  SOF    = RECORD O,S : WORD; END;
VAR   J,K    : WORD;
      B2     : LONGINT;
      V2     : POINTER;
BEGIN
  B2 := BIS + LONGINT(WID);

  SETSEG(VADDR(BIS).S);
  IF VADDR(BIS).S = VADDR(B2).S THEN BEGIN
    MOVE(VON^,MEM[$A000:BIS],WID);
  END ELSE BEGIN
    J := VADDR(B2).A;
    K := WID - J;
    MOVE(VON^,MEM[$A000:BIS],K);
    SETSEG(VADDR(B2).S);
    V2 := VON; INC(SOF(V2).O,K);
    MOVE(V2^,MEM[$A000:0],J);
  END;
END; { RAMTOVGA }


PROCEDURE VGATORAM(VON:POINTER;BIS:LONGINT;WID:WORD);
TYPE  SOF    = RECORD O,S : WORD; END;
VAR   J,K    : WORD;
      B2     : LONGINT;
      V2     : POINTER;
BEGIN
  B2 := BIS + LONGINT(WID);

  SETSEG(VADDR(BIS).S);
  IF VADDR(BIS).S = VADDR(B2).S THEN BEGIN
    MOVE(MEM[$A000:BIS],VON^,WID);
  END ELSE BEGIN
    J := VADDR(B2).A;
    K := WID - J;
    MOVE(MEM[$A000:BIS],VON^,K);
    SETSEG(VADDR(B2).S);
    V2 := VON; INC(SOF(V2).O,K);
    MOVE(MEM[$A000:0],V2^,J);
  END;
END; { VGATORAM }

procedure initgraph;
var r:registers;
    command:byte;
begin
 OrigMode := LastMode;
 if mode=1 then
 begin
  with r do
  begin
   r.ah:=$0;
   r.al:=$13;
   intr($10,r);
   maxx:=319;
   maxy:=199;
  end;
  inline($BA/$C4/$03/ {0105: MOV    DX,03C4 ;Nastaveni adresy sekvenceru }
         $B0/$04/     {0108: MOV    AL,04   ;na mod zmeny pameti.        }
         $EE/         {010A: OUT    DX,AL   ;Nastav to.                  }
         $42/         {010B: INC    DX      ;Nastaveni na data sekvenceru}
         $EC/         {010C: IN     AL,DX   ;Cti to                      }
         $24/$F7/     {010D: AND    AL,F7   ;Bit 3:=0:4 Planes nicht chainen}
         $0C/$04/     {010F: OR     AL,04   ;Bit 2 nastav (EGA RAM > 64Kb}
         $EE/         {0111: OUT    DX,AL   ;Nastav to                   }
         $BA/$C4/$03/ {0112: MOV    DX,03C4 ;Adresovy registr sekvenceru    }
         $B0/$02/     {0115: MOV    AL,02   ;na mod maska mapy              }
         $EE/         {0117: OUT    DX,AL   ;Nastav to                      }
         $42/         {0118: INC    DX      ;Nastaveni na data sekvenceru   }
         $B0/$0F/     {0119: MOV    AL,0F   ;na 4. bit                      }
         $EE/         {011B: OUT    DX,AL   ;Nastav to                      }
         $B8/$00/$A0/ {011C: MOV    AX,A000 ;Kopyruj na $A000 nuly          }
         $8E/$C0/     {011F: MOV    ES,AX   ;$8000 je velikost stranky      }
         $29/$FF/     {0121: SUB    DI,DI   ;4*$8000 pro 4 stranky          }
         $89/$F8/     {0123: MOV    AX,DI   ;potom budou                    }
         $B9/$00/$80/ {0125: MOV    CX,8000 ;smazany                        }
         $FC/         {0128: CLD            ;vsechny                        }
         $F2/         {0129: REPNZ          ;(4)                            }
         $AB/         {012A: STOSW          ;videostranky                   }
         $BA/$D4/$03/ {012B: MOV    DX,03D4 ;CRT-Controller ansteuern       }
         $B0/$14/     {012E: MOV    AL,14   ;Underline-location-Register    }
         $EE/         {0130: OUT    DX,AL   ;auswaehlen                     }
         $42/         {0131: INC    DX      ;Wert aus zugehoerigem          }
         $EC/         {0132: IN     AL,DX   ;Datenregister auslesen         }
         $24/$BF/     {0133: AND    AL,BF   ;Bit 6:=0: keine Doppelwort-    }
         $EE/         {0135: OUT    DX,AL   ;adressierung von Daten im Bild-}
         $4A/         {0136: DEC    DX      ;schirmspeicher durchfuehren    }
         $B0/$17/     {0137: MOV    AL,17   ;Mode-control-Register          }
         $EE/         {0139: OUT    DX,AL   ;auswaehlen                     }
         $42/         {013A: INC    DX                                      }
         $EC/         {013B: IN     AL,DX                                   }
         $0C/$40/     {013C: OR     AL,40   ;Bit 6:=1: Adressierung des     }
         $EE);        {013E: OUT    DX,AL   ;Speichers=lineares Bitfeld     }
  end else
 begin
  case mode of
   mode640x350:begin
                maxx:=639;maxy:=349;command:=$2d;
               end;
   mode640x400:begin
                maxx:=639;maxy:=399;command:=$2f;
               end;
   mode640x480:begin
                maxx:=639;maxy:=479;command:=$2e;
               end;
   mode800x600:begin
                maxx:=799;maxy:=699;command:=$30;
               end;
   mode1024x768:begin
                if not useet4000 then
                begin
                 maxx:=799;maxy:=699;command:=$30;
                end else
                begin
                 maxx:=1023;maxy:=767;command:=$38;
                end;
               end;
   end;
   checkvga(command);
 end;
 vx1:=0;vy1:=0;vx2:=maxx;vy2:=maxy;
 InGraph:=true;
 getintvec($08,@OldVec08);
 setintvec($08,@INT08);
end;
function getgraphmode:byte;
var r:registers;
begin
 r.ah:=$0F;
 getgraphmode:=r.al;
 intr($10,r);
end;
procedure drawto(page:byte);
begin
 if page>4 then
 begin
  SVGAerror:=2;
  exit;
 end;
 drawpage:=page;
end;
function getscreen:byte;
var r:registers;
begin
 getscreen:=drawpage;
end;
procedure closegraph;
begin
 setintvec($08,@OldVec08);
 TextMode(OrigMode);
 InGraph:=false;
end;
procedure fadeto(fade:BWtype);
var di,si,i,l:byte;reg:registers;pal,temp:array[0..255,1..3] of byte;
procedure setDAC(d:byte);
var re:registers;i,l:integer;
begin
 with re do
 begin
  for i:=0 to 255 do for l:=1 to 3 do
  begin
   temp[i,l]:=(word(pal[i,l])*d) div 64;
  end;
  re.ah:=$10;
  re.al:=$12;
  re.bx:=0;
  re.cx:=255;
  re.es:=seg(temp);
  re.dx:=ofs(temp);
  intr($10,re);
 end;
end;
procedure setDAC1(d:byte);
var re:registers;i,l:integer;
begin
 with re do
 begin
  for i:=0 to 255 do for l:=1 to 3 do
{  if (pal[i,l]*d div 64<=64) then}
  begin
   temp[i,l]:=(word(pal[i,l])*d) div 64;
  end;
  re.ah:=$10;
  re.al:=$12;
  re.bx:=0;
  re.cx:=255;
  re.es:=seg(temp);
  re.dx:=ofs(temp);
  intr($10,re);
 end;
end;

begin
  reg.ah:=$10;
  reg.al:=$17;
  reg.bx:=0;
  reg.cx:=255;
  reg.es:=seg(pal);
  reg.dx:=ofs(pal);
  intr($10,reg);
  for i:=0 to 255 do for l:=1 to 3 do temp[i,l]:=pal[i,l];
  if fade=white then for di:=1 to 63 do setdac1(di);
  if fade=black then for di:=63 downto 0 do setdac(di);
end;

procedure Screen(page:BYTE);
begin
 if page>4 then
 begin
  SVGAerror:=2;
  exit;
 end;
 asm
  MOV DX,$3D4
  MOV AL,$0D
  CLI
  OUT DX,AL
  INC DX
  MOV BL,page
  MOV SI,BX
  AND SI,3
  SHL SI,1
  ADD SI,OFFSET Offset_Adr-StartIndex*2
  LODSW
  OUT DX,AL
  DEC DX
  MOV AL,$0C
  OUT DX,AL
  INC DX
  MOV AL,AH
  OUT DX,AL
  STI
 end;
end;
PROCEDURE CS_TranslateTab; ASSEMBLER;
ASM
 DB 1,2,4,8
END;
function  GetImage(x1,y1,x2,y2:integer):pointer;
VAR len,breite,hoehe,StartAdr,actualAdr,SegmAdr,pa:WORD;
    p:POINTER;
BEGIN
 pa:=drawpage;
 was_cut:=FALSE; left_cut:=0; right_cut:=0; top_cut:=0; bottom_cut:=0;
 dec(x1,StartVirtualX);   {Bildschirmkoordinaten berechnen}
 dec(y1,StartVirtualY);
 IF (x1>XMAX) or (y1>YMAX) or (x2<0) or (y2<0) or (x1>x2) or (y1>y2)
  THEN BEGIN  {Bildausschnitt nicht auf dem Bildschirm}
       GetImage:=NIL;
       exit
       END;
 IF x1<0 THEN BEGIN left_cut :=-x1; x1:=0; was_cut:=TRUE END;
 IF y1<0 THEN BEGIN top_cut:=-y1; y1:=0; was_cut:=TRUE END;
 IF x2>XMAX THEN BEGIN right_cut :=x2-XMAX; x2:=XMAX; was_cut:=TRUE END;
 IF y2>YMAX THEN BEGIN bottom_cut:=y2-YMAX; y2:=YMAX; was_cut:=TRUE END;

 breite:=SUCC(x2-x1); hoehe:=SUCC(y2-y1);
 len:=breite*hoehe+2*2; {1 Pixel=1 Byte; dazu: 2 Woerter fuer breite & hoehe}
 IF len>MaxAvail
  THEN BEGIN
        SVGAError:=1;
        GetImage:=NIL;
        exit
       END;
 IF (pa>4)
 THEN BEGIN
        SVGAError:=2;
        GetImage:=NIL;
        exit
       END
  ELSE SegmAdr:=Segment_Adr[pa];
 GetMem(p,len);         {Speicher auf dem Heap besorgen}
 ASM
    CLD
    LES DI,p        {ES:DI = Zeiger auf den besorgten Speicher}
    MOV AX,breite
    STOSW           {Breite zuerst ablegen...}
    MOV AX,hoehe
    STOSW           {...gefolgt von der Hoehe, danach dann die Daten}

    MOV BX,AX       {BX:=hoehe (fuer spaeter) }
    MOV SI,y1
    SHL SI,1
    MOV SI,CS:[OFFSET gadr + SI]   {SI:=y1*LINESIZE}
    MOV AX,x1
    MOV DL,AL
    SHR AX,1
    SHR AX,1
    ADD SI,AX       {SI:=Offsetanteil der Startadresse}
    MOV StartAdr,SI
    MOV actualAdr,SI
    AND DL,3
    MOV AH,DL
    MOV AL,4
    MOV DX,3CEh
    OUT DX,AX       {Startplane anwaehlen}
    MOV DS,SegmAdr

    MOV DX,breite
    ADD DX,3
    SHR DX,1
    SHR DX,1        {DX = Anzahl zu sichernde Bytes je Zeile}

  @L1:
    MOV CX,DX       {Daten einer Zeile abspeichern}
    REP MOVSB
    MOV SI,actualAdr  {Quellzeiger um 1 Grafikzeile weitersetzen}
    ADD SI,LINESIZE
    MOV actualAdr,SI
    DEC BX          {Zeilenzaehler verringern}
    JNE @L1

    INC AH          {naechste Plane anwaehlen}
    CMP AH,4
    JNE @nowrap1    {wrap in den Bitplanes bedeutet: Startadresse}
    MOV AH,0        {um 1 Adresse weitersetzen! }
    INC StartAdr
  @nowrap1:
    MOV DX,3CEh
    OUT DX,AX
    MOV BX,hoehe
    MOV DX,breite
    INC DX
    INC DX
    SHR DX,1
    SHR DX,1
    MOV SI,StartAdr
    MOV actualAdr,SI

  @L2:
    MOV CX,DX
    REP MOVSB
    MOV SI,actualAdr
    ADD SI,LINESIZE
    MOV actualAdr,SI
    DEC BX
    JNE @L2

    INC AH
    CMP AH,4
    JNE @nowrap2
    MOV AH,0
    INC StartAdr
  @nowrap2:
    MOV DX,3CEh
    OUT DX,AX
    MOV BX,hoehe
    MOV DX,breite
    INC DX
    SHR DX,1
    SHR DX,1
    MOV SI,StartAdr
    MOV actualAdr,SI

  @L3:
    MOV CX,DX
    REP MOVSB
    MOV SI,actualAdr
    ADD SI,LINESIZE
    MOV actualAdr,SI
    DEC BX
    JNE @L3

    INC AH
    CMP AH,4
    JNE @nowrap3
    MOV AH,0
    INC StartAdr
  @nowrap3:
    MOV DX,3CEh
    OUT DX,AX
    MOV BX,hoehe
    MOV DX,breite
    SHR DX,1
    SHR DX,1
    MOV SI,StartAdr
    MOV actualAdr,SI

  @L4:
    MOV CX,DX
    REP MOVSB
    MOV SI,actualAdr
    ADD SI,LINESIZE
    MOV actualAdr,SI
    DEC BX
    JNE @L4

    MOV AX,SEG @DATA
    MOV DS,AX
 END;
 GetImage:=p
END;

procedure PutImage(x,y:integer;p:pointer);
VAR breite,hoehe,SegmAdr,actualAdr,StartAdr,breite1,breite2,breite3,breite4,
    licut_div4,topcut,pl_adr1,pl_adr2,pl_adr3,pl_adr4:WORD;
    licutoff,temp,pa:INTEGER;
BEGIN
 pa:=drawpage;
 IF p=NIL THEN exit;
 dec(x,StartVirtualX);   {Bildschirmkoordinaten berechnen}
 dec(y,StartVirtualY);
 IF (x>XMAX) or (y>YMAX) THEN exit;
 IF (pa>4)
  THEN BEGIN
        SVGAError:=2;
        playsound(100,10);
        exit
       END
  ELSE SegmAdr:=Segment_Adr[pa];
 breite:=MEMW[SEG(p^):OFS(p^)];
 hoehe :=MEMW[SEG(p^):OFS(p^)+2];
 IF (x+breite<=0) or (y+hoehe<=0) THEN exit;
 IF x<0 THEN BEGIN licutoff:=-x; x:=0 END
        ELSE licutoff:=0;
 IF y<0 THEN BEGIN
              topcut:=-y;
              y:=0
             END
        ELSE topcut:=0;

 breite1:=(breite + 3) shr 2;  {Breite einer Zeile fuer die erste, zweite,}
 breite2:=(breite + 2) shr 2;  {dritte und vierte Bitplane}
 breite3:=(breite + 1) shr 2;
 breite4:=(breite + 0) shr 2;

 licut_div4:=licutoff shr 2;
 pl_adr1:=4 +licut_div4 +topcut*breite1;
 pl_adr2:=4 +licut_div4 +topcut*breite2 +hoehe*breite1;
 pl_adr3:=4 +licut_div4 +topcut*breite3 +hoehe*(breite1+breite2);
 pl_adr4:=4 +licut_div4 +topcut*breite4 +hoehe*(breite1+breite2+breite3);

 ASM
    CLD
    MOV AX,licutoff
    AND AL,3
    OR AL,AL
    JE @no_exchange
    CMP AL,1
    JNE @L10

    MOV AX,pl_adr2     {Verschiebung um 1 Bit: }
    MOV BX,pl_adr3     {AX=Plane2,BX=Plane3,CX=Plane4,DX=Plane1}
    MOV CX,pl_adr4
    MOV DX,pl_adr1     {wrap-around, deshalb: Adresse um 1 erhoehen, was  }
    INC DX             {einer Weitersetzung um 4 Bildpunkte entspricht    }
    MOV pl_adr1,AX     {(z.B.: Pixel (1,5,9,...),(2,6,10,...),(3,7,11,...)}
    MOV pl_adr2,BX     {und (0,4,8,...); letztere Bitplane wird um 1 Byte }
    MOV pl_adr3,CX     {weitergesetzt: liefert (richtige) (4,8,12,...)    }
    MOV pl_adr4,DX     {Folge (Planes abwechselnd von oben nach unten lesen!}
    MOV AX,breite2     {Jetzt Planebreiten: }
    MOV BX,breite3     {AX=Plane2,BX=Plane3,CX=Plane4,DX=Plane1}
    MOV CX,breite4
    MOV DX,breite1
    JMP @store

  @L10:
    CMP AL,2
    JNE @L20

    MOV AX,pl_adr3     {Verschiebung um 2 Bit: }
    MOV BX,pl_adr4     {AX=Plane3,BX=Plane4,CX=Plane1,DX=Plane2}
    MOV CX,pl_adr1
    INC CX
    MOV DX,pl_adr2
    INC DX
    MOV pl_adr1,AX
    MOV pl_adr2,BX
    MOV pl_adr3,CX
    MOV pl_adr4,DX
    MOV AX,breite3     {dto. fuer Planebreiten: }
    MOV BX,breite4     {AX=Plane3,BX=Plane4,CX=Plane1,DX=Plane2}
    MOV CX,breite1
    MOV DX,breite2
    JMP @store
  @L20:
    MOV AX,pl_adr4     {Verschiebung um 3 Bit: }
    MOV BX,pl_adr1     {AX=Plane4,BX=Plane1,CX=Plane2,DX=Plane3}
    INC BX
    MOV CX,pl_adr2
    INC CX
    MOV DX,pl_adr3
    INC DX
    MOV pl_adr1,AX
    MOV pl_adr2,BX
    MOV pl_adr3,CX
    MOV pl_adr4,DX
    MOV AX,breite4     {dto. fuer Planebreiten: }
    MOV BX,breite1     {AX=Plane4,BX=Plane1,CX=Plane2,DX=Plane3}
    MOV CX,breite2
    MOV DX,breite3
  @store:
    MOV breite1,AX
    MOV breite2,BX
    MOV breite3,CX
    MOV breite4,DX

  @no_exchange:        {jetzt gilt: (pl_adr?,breite?) enthalten die Source-}
                       {Bitplanes/-breiten in der richtigen Reihenfolge    }

    MOV AX,topcut
    SUB hoehe,AX       {Hoehe um evtl. oberen cutoff korrigieren}
    MOV AX,licutoff
    SUB breite,AX      {dto. fuer Breite und linken cutoff}

    MOV AX,x           {falls Ausschnitt ueber rechten Bildschirmrand}
    ADD AX,breite      {ragen wuerde: rechten cutoff bestimmen       }
    SUB AX,XMAX+1
    JLE @no_recutoff
    SUB breite,AX      {AX Punkte rechts abschneiden}
  @no_recutoff:

    MOV AX,y           {genau dasselbe fuer unteren Bildschirmrand}
    ADD AX,hoehe
    SUB AX,YMAX+1
    JLE @no_bocutoff
    SUB hoehe,AX       {AX Zeilen unten abschneiden}
  @no_bocutoff:


    LDS SI,p
    ADD pl_adr2,SI       {Offsetanteil des Zeigers zu den Planeadr. addieren}
    ADD pl_adr3,SI
    ADD pl_adr4,SI

    ADD SI,pl_adr1    {breite,hoehe und Teile oberhalb des Bildschirms}
    MOV ES,SegmAdr

    MOV DI,y
    SHL DI,1
    MOV DI,CS:[OFFSET gadr + DI]  {DI:=y*LINESIZE}
    MOV AX,x
    MOV BL,AL
    SHR AX,1
    SHR AX,1
    ADD DI,AX         {DI:=y*LINESIZE +(x DIV 4)}
    MOV StartAdr,DI
    MOV actualAdr,DI

    AND BX,3          {Startplane:=x mod 3}
    MOV AH,CS:[OFFSET CS_TranslateTab + BX]
    MOV AL,2
    MOV DX,3C4h
    OUT DX,AX         {als Schreibplane anwaehlen}

    MOV DX,hoehe
    MOV DI,actualAdr

    MOV BX,breite
    ADD BX,3
    SHR BX,1
    SHR BX,1
    mov cx,bx
  @L1:
    push si
    REP MOVSB
    pop si
    mov cx,bx
    add si,breite1
    MOV DI,actualAdr
    ADD DI,LINESIZE
    MOV actualAdr,DI
    DEC DX
    JNE @L1


    SHL AH,1          {naechste Bitplane anwaehlen; bei einem wrap von}
    CMP AH,16         {Bitplane 3 zu Bitplane 0 muss dabei die Start- }
    JNE @nowrap1      {adresse um 1 Byte weitergesetzt werden         }
    MOV AH,1
    INC StartAdr
  @nowrap1:
    MOV DX,3C4h
    OUT DX,AX
    MOV SI,pl_adr2
    MOV DI,StartAdr
    MOV actualAdr,DI
    MOV DX,hoehe
    MOV BX,breite
    INC BX
    INC BX
    SHR BX,1
    SHR BX,1
    mov cx,bx
  @L2:
    push si
    REP MOVSB
    pop si
    mov cx,bx
    add si,breite2
    MOV DI,actualAdr
    ADD DI,LINESIZE
    MOV actualAdr,DI
    DEC DX
    JNE @L2


    SHL AH,1
    CMP AH,16
    JNE @nowrap2
    MOV AH,1
    INC StartAdr
  @nowrap2:
    MOV DX,3C4h
    OUT DX,AX
    MOV SI,pl_adr3
    MOV DI,StartAdr
    MOV actualAdr,DI
    MOV DX,hoehe
    MOV BX,breite
    INC BX
    SHR BX,1
    SHR BX,1
    mov cx,bx
  @L3:
    push si
    REP MOVSB
    pop si
    mov cx,bx
    add si,breite3
    MOV DI,actualAdr
    ADD DI,LINESIZE
    MOV actualAdr,DI
    DEC DX
    JNE @L3


    SHL AH,1
    CMP AH,16
    JNE @nowrap3
    MOV AH,1
    INC StartAdr
  @nowrap3:
    MOV DX,3C4h
    OUT DX,AX
    MOV SI,pl_adr4
    MOV DI,StartAdr
    MOV actualAdr,DI
    MOV DX,hoehe
    MOV BX,breite
    SHR BX,1
    SHR BX,1
    mov cx,bx
  @L4:
    push si
    REP MOVSB
    pop si
    mov cx,bx
    add si,breite4
    MOV DI,actualAdr
    ADD DI,LINESIZE
    MOV actualAdr,DI
    DEC DX
    JNE @L4

    MOV AX,SEG @DATA
    MOV DS,AX
 END;
END;
procedure clearscreen;
var i,l:word;
begin
 for l:=vx1 to vx2 do for i:=vy1 to vy2 do putpixel(l,i,0);
end;
procedure fillscreen(color:byte);
var i,l:word;
begin
 for l:=vx1 to vx2 do for i:=vy1 to vy2 do putpixel(l,i,color);
end;
procedure rectangle(x,y,x1,y1:word;color1:byte);
var i,l:integer;
begin
 for i:=0 to x1-x do putpixel(x+i,y,color1);
 for i:=0 to y1-y do putpixel(x,y+i,color1);
 for i:=0 to y1-y do putpixel(x1,y+i,color1);
 for i:=0 to x1-x do putpixel(x+i,y1,color1);
end;
procedure bar(x,y,x1,y1:word;color2:byte);
var i,l:word;
begin
 for i:=x to x1 do for l:=y to y1 do putpixel(i,l,color2);
end;
{procedure ellipse(x,y,x0,y0:word;color1:byte);
var q,w:word;
begin
w:=(x0+y0) * 2;q:=round(2*pi*w);
for i:=1 to q do putpixel(round(sin(round(i))*x0)+x,round(cos(round(i))*y0)+y,color1);
end;
procedure circle(x,y,p:word;color1:byte);
var q:integer;
begin
 q:=round(4*pi*p)+p*2;
 for i:=1 to q do putpixel(round(sin(round(i))*p)+x,round(cos(round(i))*p)+y,color1);
end;}
Procedure Circle(x,y,r:integer;c:byte);
var x1,y1:integer;
    a : real;
begin
 a:=0;
 repeat
  y1:=round(-1*(r*sin(a)))+y;
  x1:=round(r*cos(a))+x;
  PutPixel(x1,y1,c);
  a:=a+0.25;
 until a=360.25;
end;
Procedure Ellipse(x,y,r1,r2:integer;col:byte);
var r,x1,y1:integer;
    a,b : real;
begin
 a:=0;
 r:=r2;
 b:=(r2-r1+1) div 90;
 b:=-1*b;
 repeat
  y1:=round(-1*(r*sin(a)))+y;
  x1:=round(r*cos(a))+x;
  PutPixel(x1,y1,col);
  r:=r+round(b);
  a:=a+0.25;
 until a=90.25;
end;
Procedure Line (X, Y, X2, Y2 : integer; Color : Byte);
var
 d,dx,dy,ai,bi,xi,yi : integer;
begin
 if x < x2 then begin xi := 1; dx := x2-x; end
 else begin xi := -1; dx := x-x2; end;
 if y < y2 then begin yi := 1; dy := y2-y; end
 else begin yi := -1; dy := y-y2; end;
 if (x>=0)and(x<=639)and(y>=0)and(y<=479)then putpixel(x,y,color);
 if dx > dy then begin
  ai := (dy-dx)*2; bi := dy*2; d := bi-dx;
  repeat
   if d >= 0 then begin inc(y,yi); inc(d,ai); end else inc(d,bi);
   inc(x,xi); if (x>=0)and(x<=639)and(y>=0)and(y<=479)then putpixel(x,y,color);
  until x = x2;
 end
 else begin
  ai := (dx-dy)*2; bi := dx*2; d := bi-dy;
  repeat
   if d >= 0 then begin inc(x,xi); inc(d,ai); end else inc(d,bi);
   inc(y,yi); if (x>=0)and(x<=639)and(y>=0)and(y<=479)then putpixel(x,y,color);
  until y = y2;
 end;
end;
procedure setborder(b:byte);
var r:registers;
begin
 r.ah:=$10;
 r.al:=$1;
 r.bh:=b;
 intr($10,r);
end;
function getborder:byte;
var r:registers;
begin
 r.ah:=$10;
 r.al:=$8;
 intr($10,r);
 getborder:=r.bh;
end;
procedure setpalette(paleta:palettetype;prvni,posledni:byte);
var r:registers;
begin
with r do
begin
 r.es:=seg(paleta);
 r.dx:=ofs(paleta);
 r.ah:=$10;
 r.al:=$12;
 r.bx:=prvni;
 r.cx:=posledni;
 intr($10,r);
end;
end;
procedure getpalette(var paleta:palettetype;prvni,posledni:byte);
var r:registers;uuu:palettetype;i:integer;
begin
with r do
begin
 r.es:=seg(uuu);
 r.dx:=ofs(uuu);
 r.ah:=$10;
 r.al:=$17;
 r.bx:=prvni;
 r.cx:=posledni;
 intr($10,r);
 paleta:=uuu;
end;
end;
procedure loadpalette1(prvni,posledni:byte);
var r:registers;uuu:array[1..768] of byte;i:integer;
begin
with r do
begin
 r.es:=seg(newpalette);
 r.ds:=seg(newpalette);
 r.dx:=ofs(newpalette);
 r.ah:=$10;
 r.ax:=$1012;
 r.bx:=prvni;
 r.cx:=posledni;
 intr($10,r);
end;
end;
procedure loadpalette2(prvni,posledni:byte);
var r:registers;uuu:array[1..768] of byte;i:integer;
begin
with r do
begin
 r.es:=seg(palette2);
 r.ds:=seg(palette2);
 r.dx:=ofs(palette2);
 r.ah:=$10;
 r.ax:=$1012;
 r.bx:=prvni;
 r.cx:=posledni;
 intr($10,r);
end;
end;
procedure loaddefaulpalette(prvni,posledni:byte);
var r:registers;uuu:array[1..768] of byte;i:integer;
begin
with r do
begin
 r.es:=seg(defaulpal);
 r.ds:=seg(defaulpal);
 r.dx:=ofs(defaulpal);
 r.ah:=$10;
 r.ax:=$1012;
 r.bx:=prvni;
 r.cx:=posledni;
 intr($10,r);
end;
end;
procedure scrollscreen(x,y,x1,y1:word;c:cursetype;preklop:boolean);
var i,l:integer;
begin
 case c of
  ToLeft:for l:=y to y1 do for i:=x to x1 do putpixel(i,l,getpixel(i+1,l));
  ToRight:for l:=y to y1 do for i:=x1 downto x do putpixel(i,l,getpixel(i-1,l));
  ToUp:for l:=y to y1 do for i:=x to x1 do putpixel(i,l,getpixel(i,l+1));
  ToDown:for l:=y1 downto y do for i:=x to x1 do putpixel(i,l,getpixel(i,l-1));
 end;
end;
procedure copypage(fp,dp:byte);
var i,l,d:integer;x:byte;p:pointer;
    len,breite,hoehe:word;
begin
 d:=drawpage;
 breite:=SUCC(vx2-vx1); hoehe:=SUCC(2-1);
 len:=breite*hoehe+2*2;
 if maxx=319 then for l:=vy1 to vy2 do
 begin
  drawpage:=fp;
  p:=getimage(vx1,l,vx2,l+1);
  drawpage:=dp;
  putimage(vx1,l,p);
  freemem(p,len);
 end else
 for i:=vx1 to vx2 do for l:=vy1 to vy2 do
 begin
  drawpage:=fp;
  x:=getpixel(i,l);
  drawpage:=dp;
  putpixel(i,l,x);
 end;
 drawpage:=d;
end;
procedure copypagecut(fp,vvx1,vvy1,vvx2,vvy2,dp,dx,dy:word);
var i,l,d:integer;x:byte;p:pointer;
    len,breite,hoehe:word;
begin
 d:=drawpage;
 breite:=SUCC(vvx2-vvx1); hoehe:=SUCC(2-1);
 len:=breite*hoehe+2*2;
 if maxx=319 then for l:=vy1+vvy1 to vy2+vvy2 do
 begin
  drawpage:=fp;
  p:=getimage(vx1+vvx1,l,vy2+vvx2,l+1);
  drawpage:=dp;
  putimage(vx1+vvx1,l,p);
  freemem(p,len);
 end else
 for i:=vx1+vvx1 to vx2+vvx2 do for l:=vy1+vvy1 to vy2+vvy2 do
 begin
  drawpage:=fp;
  x:=getpixel(i,l);
  drawpage:=dp;
  putpixel(i-vvx1+dx,l-vvy1+dy,x);
 end;
 drawpage:=d;
end;
procedure rollpalette(odb,dob:byte;kam:cursetype);
var i,l:integer;x,y:palettetype;
begin
 getpalette(x,0,255);getpalette(y,0,255);
 if kam=ToUp then
 begin
  for i:=odb to dob-1 do
  begin
   x[i]:=y[i+1];
  end;
  x[dob]:=y[odb];
 end;
 if kam=ToDown then
 begin
  for i:=dob downto odb+1 do
  begin
   x[i]:=y[i-1];
  end;
  x[odb]:=y[dob];
 end;
 setpalette(x,0,255);
end;
Procedure LoadFli(filename:string);
const
ErrorMsgs:string='Chyba pri otevirani souboru  !'+#13+#10+
                 'Chyba ve formatu  !'+#13+#10+
                 'Chyba pri alokaci pameti  !'+#13+#10+
                 'Snimek je vetsi nez 64 kB  !'+#13+#10+
                 'Neznamy typ bloku (chunk)  !'+#13+#10+
                 'Balicku s barvama je prilis mnoho  !'+#13+#10+
                 'Stejnych radku je prilis mnoho (radku>255 (proc?)) '+#13+#10+
                 'Menicich se radku je prilis mnoho (radku>255 (proc?)) '+#13+#10;
MemSize   :word=  0;
AllocSeg  :word=  0;
ActFrame  :word=  0;
ActPos    :word=  0;
var FLIH  :array[1..128] of byte;
    Handle:file;
    x     :pointer;
begin
assign(handle,filename);reset(handle,1);
getmem(x,$FFF*16);
allocseg:=seg(x^);
blockread(handle,flih,128);
if word(flih[4])=$af12 then exit;
actframe:=word(flih[6]);
blockread(handle,x^,16);
{FrameLoop}
actframe:=actframe-1;
if memw[seg(x^):ofs(x^)+4]<>$f1fa then exit;
if (memw[seg(x^):ofs(x^)+6]<>0) and (memw[seg(x^):ofs(x^)]<>$FFFF) then exit;
end;

Procedure LoadTga(name:string);
var x,y,i : integer;
    f    : file;
    c    : byte;
    bl,df: longint;
begin
 df:=0;
 bl:=18;
 Assign(f,name);
 Reset(f,1);
 bl:=df+786;
 seek(f,bl);
 BlockRead(f,c,1);
 PutPixel(0,0,c);
 Seek(f,bl);
 BlockRead(f,mem[$A000:0],65280);
 for x:=0 to 639 do
  begin
   BlockRead(f,c,1);
   PutPixel(x,102,c);
  end;
 BlockRead(f,mem[$A000:384],64640);
 for y:=204 to 204 do
 for x:=0 to 639 do
 begin
  BlockRead(f,c,1);
  PutPixel(x,y,c);
 end;
 BlockRead(f,mem[$A000:128],65280);
 for x:=0 to 639 do
 begin
  BlockRead(f,c,1);
  PutPixel(x,307,c);
 end;
 BlockRead(f,mem[$A000:512],64640);
 for x:=0 to 639 do
 begin
  BlockRead(f,c,1);
  PutPixel(x,409,c);
 end;
 BlockRead(f,mem[$A000:256],44800);
 close(f);
 {RestorePalette;}
end;
procedure PCXfileinfo(s:string;var inf:PCXinfotype);
CONST LINLEN   = 2048;
      PCXHDRSIZE  = 128;
TYPE  CMAPTYP  = ARRAY[0..255,0..2] OF BYTE;
      PALTYP   = ARRAY[0..15,0..2] OF BYTE;
TYPE  HDRTYP = RECORD
        ID,VER,COMPR,BPP  : BYTE;
        X1,Y1,X2,Y2       : WORD;
        RX,RY             : WORD;
        HDRPAL            : PALTYP;
        RES               : BYTE;
        PLANES            : BYTE;
        BYTES             : WORD;
        PAL2              : WORD;
        FILL              : ARRAY[1..58] OF BYTE;
        WID,HIG           : WORD;
        CMAPSIZ           : WORD;
        MONO              : BOOLEAN;
      END;
var   f                   : file;
      CMAP                : CMAPTYP;
      PAL                 : palettetype ABSOLUTE CMAP;
      HDR                 : HDRTYP;
      LINBUF              : ARRAY[0..LINLEN] OF BYTE;

FUNCTION LIESHDR:BOOLEAN;
VAR   FP   : LONGINT;
      I,J  : INTEGER;
      W    : WORD;
BEGIN
  LIESHDR := FALSE;
  BLOCKREAD(F,HDR,PCXHDRSIZE,W);
  IF W <> PCXHDRSIZE THEN EXIT;
  WITH HDR DO BEGIN
    IF ID <> 10 THEN EXIT;
    WID := SUCC(X2 - X1);
    HIG := SUCC(Y2 - Y1);
    CMAPSIZ := 1 SHL (BPP * PLANES);

    IF CMAPSIZ = 2 THEN BEGIN
      CMAP[0,0] := 0;   CMAP[0,1] := 0;   CMAP[0,2] := 0;
      CMAP[1,0] := $FF; CMAP[1,1] := $FF; CMAP[1,2] := $FF;
    END;
    IF CMAPSIZ = 4 THEN BEGIN
      CMAP[0,0] := 0;   CMAP[0,1] := 0;   CMAP[0,2] := 0;
      CMAP[1,0] := 85;  CMAP[1,1] := $FF; CMAP[1,2] := $FF;
      CMAP[2,0] := $FF; CMAP[2,1] := 85;  CMAP[2,2] := $FF;
      CMAP[3,0] := $FF; CMAP[3,1] := $FF; CMAP[3,2] := $FF;
    END;
    IF CMAPSIZ = 16 THEN BEGIN
      MOVE(HDR.HDRPAL,CMAP,48);
    END;
    IF CMAPSIZ = 256 THEN BEGIN
      FP := FILEPOS(F);
      SEEK(F,FILESIZE(F) - 768);
      BLOCKREAD(F,CMAP,768,W);
      SEEK(F,FP);
    END;
    FOR I := 0 TO PRED(CMAPSIZ) DO BEGIN
      FOR J := 0 TO 2 DO CMAP[I][J] := CMAP[I][J] SHR 2;
    END;
    MONO := (BPP = 1) AND (PLANES = 1);
  END;
  LIESHDR := TRUE;
END;
begin
 assign(f,s);reset(f,1);
 LIESHDR;
 close(f);
 inf.ver:=hdr.ver;
 inf.comp:=hdr.compr;
 inf.x:=hdr.wid;
 inf.y:=hdr.hig;
 inf.palette:=pal;
end;
procedure loadPCXfile(xx,yy:word;s:string);
CONST LINLEN   = 2048;
      PCXHDRSIZE  = 128;
TYPE  CMAPTYP  = ARRAY[0..255,0..2] OF BYTE;
      PALTYP   = ARRAY[0..15,0..2] OF BYTE;
TYPE  HDRTYP = RECORD
        ID,VER,COMPR,BPP  : BYTE;
        X1,Y1,X2,Y2       : WORD;
        RX,RY             : WORD;
        HDRPAL            : PALTYP;
        RES               : BYTE;
        PLANES            : BYTE;
        BYTES             : WORD;
        PAL2              : WORD;
        FILL              : ARRAY[1..58] OF BYTE;
        WID,HIG           : WORD;
        CMAPSIZ           : WORD;
        MONO              : BOOLEAN;
      END;
var   f                   : file;
      CMAP                : CMAPTYP;
      PAL                 : array[0..255,1..3] of byte ABSOLUTE CMAP;
      HDR                 : HDRTYP;
      LINBUF              : ARRAY[0..LINLEN] OF BYTE;

FUNCTION LIESHDR:BOOLEAN;
VAR   FP   : LONGINT;
      I,J  : INTEGER;
      W    : WORD;
BEGIN
  LIESHDR := FALSE;
  BLOCKREAD(F,HDR,PCXHDRSIZE,W);
  IF W <> PCXHDRSIZE THEN EXIT;
  WITH HDR DO BEGIN
    IF ID <> 10 THEN EXIT;
    WID := SUCC(X2 - X1);
    HIG := SUCC(Y2 - Y1);
    CMAPSIZ := 1 SHL (BPP * PLANES);

    IF CMAPSIZ = 2 THEN BEGIN
      CMAP[0,0] := 0;   CMAP[0,1] := 0;   CMAP[0,2] := 0;
      CMAP[1,0] := $FF; CMAP[1,1] := $FF; CMAP[1,2] := $FF;
    END;
    IF CMAPSIZ = 4 THEN BEGIN
      CMAP[0,0] := 0;   CMAP[0,1] := 0;   CMAP[0,2] := 0;
      CMAP[1,0] := 85;  CMAP[1,1] := $FF; CMAP[1,2] := $FF;
      CMAP[2,0] := $FF; CMAP[2,1] := 85;  CMAP[2,2] := $FF;
      CMAP[3,0] := $FF; CMAP[3,1] := $FF; CMAP[3,2] := $FF;
    END;
    IF CMAPSIZ = 16 THEN BEGIN
      MOVE(HDR.HDRPAL,CMAP,48);
    END;
    IF CMAPSIZ = 256 THEN BEGIN
      FP := FILEPOS(F);
      SEEK(F,FILESIZE(F) - 768);
      BLOCKREAD(F,CMAP,768,W);
      SEEK(F,FP);
    END;
    FOR I := 0 TO PRED(CMAPSIZ) DO BEGIN
      FOR J := 0 TO 2 DO CMAP[I][J] := CMAP[I][J] SHR 2;
    END;
    MONO := (BPP = 1) AND (PLANES = 1);
  END;
  LIESHDR := TRUE;
END;
PROCEDURE ZEIGEBILD;
CONST MASKS   : ARRAY[0..7] OF BYTE = ($80,$40,$20,$10,8,4,2,1);
VAR   X,Y,Z   : WORD;
      B,B2    : BYTE;
      BW,W    : WORD;
      BITMSK  : BYTE;
      BBUF    : ARRAY[0..LINLEN] OF BYTE;

PROCEDURE VGABILD;
BEGIN
  WITH HDR DO BEGIN
    REPEAT
      IF COMPR = 1 THEN BEGIN
        REPEAT
          BLOCKREAD(F,LINBUF[X],1,W);
          IF LINBUF[X] > $BF THEN BEGIN
            B := LINBUF[X] AND $3F;
            IF B > 0 THEN BEGIN
              BLOCKREAD(F,B2,1,W);
              FILLCHAR(LINBUF[X],B,B2);
              INC(X,B);
            END;
          END ELSE BEGIN
            INC(X);
          END;
        UNTIL X >= BW;
        X := 0;
      END ELSE BEGIN
        BLOCKREAD(F,LINBUF,WID,W);
      END;
      for i:=0 to wid-1 do putpixel(xx+i,yy+y,linbuf[i]);
      INC(Y);
    UNTIL Y >= HIG;
  END;
END;

PROCEDURE MONOBILD;
VAR  I,J  : INTEGER;
BEGIN
  WITH HDR DO BEGIN
    REPEAT
      REPEAT
        BLOCKREAD(F,B,1,W);
        IF B > $BF THEN BEGIN
          B := B AND $3F;
          IF B > 0 THEN BEGIN
            BLOCKREAD(F,B2,1,W);
            FILLCHAR(LINBUF[X],B,B2);
            INC(X,B);
          END;
        END ELSE BEGIN
          LINBUF[X] := B;
          INC(X);
        END;
        IF KEYPRESSED THEN IF READKEY = ^[ THEN exit;
      UNTIL X >= BW;
      X := 0;
      for i:=0 to wid-1 do putpixel(xx+i+y*(WID shr 3) mod 320,yy+i+y*(wid shr 3) div 320,linbuf[i]);
      INC(Y);
    UNTIL Y >= HIG;
  END;
END;

PROCEDURE PLANEBILD;
VAR  I,J,K  : INTEGER;
     RW     : WORD;
BEGIN
  RW := BW * 4;
  WITH HDR DO BEGIN
    REPEAT
      REPEAT
        BLOCKREAD(F,B,1,W);
        IF B > $BF THEN BEGIN
          B := B AND $3F;
          IF B > 0 THEN BEGIN
            BLOCKREAD(F,B2,1,W);
            FILLCHAR(BBUF[X],B,B2);
            INC(X,B);
          END;
        END ELSE BEGIN
          BBUF[X] := B;
          INC(X);
        END;
      UNTIL X >= RW;
      BITMSK := 1;
      FILLCHAR(LINBUF,SIZEOF(LINBUF),0);
      X := 0;
      FOR K := 0 TO 3 DO BEGIN
        FOR I := 0 TO PRED(BW) DO BEGIN
          FOR J := 0 TO 7 DO
            IF (BBUF[X] AND MASKS[J]) <> 0 THEN
              LINBUF[8*I+J] := LINBUF[8*I+J] OR BITMSK;
          INC(X);
        END;
        BITMSK := BITMSK SHL 1;
      END;
      X := 0;
      for i:=1 to wid-1 do putpixel(xx+i,yy+y,linbuf[i]);
      INC(Y);
    UNTIL Y >= HIG;
  END;
END;

PROCEDURE ANDERESBILD;
VAR   PTRN  : ARRAY[0..3] OF BYTE;
BEGIN
  WITH HDR DO BEGIN
    REPEAT
      REPEAT
        BLOCKREAD(F,B,1,W);
        IF B > $BF THEN BEGIN
          B := B AND $3F;
          IF B > 0 THEN BEGIN
            BLOCKREAD(F,B2,1,W);
            PTRN[0] := B2 SHR 6;
            PTRN[1] := (B2 SHR 4) AND 3;
            PTRN[2] := (B2 SHR 2) AND 3;
            PTRN[3] := B2 AND 3;
            FOR I := 1 TO B DO BEGIN
              MOVE(PTRN,LINBUF[X],4);
              INC(X,4);
            END;
          END;
        END ELSE BEGIN
          LINBUF[X] := B SHR 6;
          INC(X);
          LINBUF[X] := (B SHR 4) AND 3;
          INC(X);
          LINBUF[X] := (B SHR 2) AND 3;
          INC(X);
          LINBUF[X] := B AND 3;
          INC(X);
        END;
        IF KEYPRESSED THEN IF READKEY = ^[ THEN exit;
      UNTIL X >= WID;
      X := 0;
      for i:=1 to wid do putpixel(xx+i,yy+y,linbuf[i]);
      INC(Y);
    UNTIL Y >= HIG;
  END;
END;

BEGIN
  X := 0;
  Y := 0;
  WITH HDR DO BEGIN
    BW := BYTES;
    IF MONO THEN MONOBILD
    ELSE BEGIN
      IF PLANES > 1 THEN PLANEBILD
      ELSE BEGIN
        IF BPP = 8 THEN VGABILD
                   ELSE ANDERESBILD;
      END;
    END;
  END;
END;

begin           {Begin of drawPCXfile}
 assign(f,s);reset(f,1);
 LIESHDR;
 ZEIGEBILD;
 close(f);
end;              {End of drawPCXfile}

procedure putCUTfilecut(vx,vy,x1,y1,x2,y2:word;s:string);
var i,l,x,y:word;lx,ly:longint;
    hlav:array[1..4] of byte;f:file;
    buffer:array[0..6000] of byte;
begin
 assign(f,s);reset(f,1);
 blockread(f,x,2);
 blockread(f,y,2);
 lx:=-1;ly:=0;
 repeat
   {$I-}
   BlockRead(F, Buffer, SizeOf(Buffer), l);
   {$I+}
   for i:=0 to l do
   begin
    lx:=lx+1;
    if lx>=x then begin
                   lx:=1;
                   ly:=ly+1;
                  end;
    if (lx>=x1) and (ly>=y1) and (lx<=x2) and (ly<=y2) then
                             putpixel(lx+vx-x1,ly+vy-y1,buffer[i]);
   end;
 until (l = 0);
 close(f);
end;
procedure putCUTfile(vx,vy:word;s:string);
var i,l,x,y,lx,ly:word;
    hlav:array[1..4] of byte;f:file;
    buffer:array[1..6000] of byte;
begin
 assign(f,s);reset(f,1);lx:=0;ly:=0;
 blockread(f,x,2);
 blockread(f,y,2);
 repeat
   {$I-}
   BlockRead(F, Buffer, SizeOf(Buffer), l);
   {$I+}
   for i:=1 to l do
   begin
    lx:=lx+1;
    if lx>=x then begin
                   lx:=0;
                   ly:=ly+1;
                  end;
    if buffer[i]<>0 then putpixel(lx+vx,ly+vy,buffer[i]);
   end;
 until (l = 0);
 close(f);
end;

procedure putCUTfileF(vx,vy:word;off:longint;s:string);
var i,l,x,y,lx,ly:word;
    hlav:array[1..4] of byte;f:file;
    buffer:array[1..6000] of byte;ml:longint;
    max:longint;
begin
 assign(f,s);reset(f,1);lx:=0;ly:=0;ml:=0;
 seek(f,off);
 blockread(f,x,2);
 blockread(f,y,2);
 max:=x*y+4;
 repeat
   BlockRead(F, Buffer, SizeOf(Buffer), l);
   ml:=ml+6000;
   for i:=1 to l do
   begin
    lx:=lx+1;
    if lx>=x then begin
                   lx:=0;
                   ly:=ly+1;
                  end;
    if buffer[i]<>0 then putpixel(lx+vx,ly+vy,buffer[i]);
   end;
 until (ml > max);
 close(f);
end;

procedure getpicture(x,y,x1,y1,se,off:word);
var i,l:integer;
begin
 memw[se:off]:=x1-x;
 memw[se:off+2]:=y1-y;
 for l:=y to y1 do
 for i:=x to x1 do
 begin
  mem[se:off+3+((l-y)*(x1-x))+(i-x)]:=getpixel(i,l);
 end;
end;
procedure putpicture(vx,vy:word;p:pointer);
var i,l,x,y:integer;se:word;off:word;
begin
 se:=seg(p^);off:=ofs(p^);
 x:=memw[se:off];
 y:=memw[se:off+2];
 for l:=0 to y-1 do
 for i:=0 to x-1 do
 begin
  if mem[se:off+4+(l*x)+i]<>0 then
  putpixel(i+vx,l+vy,mem[se:off+(l*x)+4+i]);
 end;
end;
procedure xputpicture(vx,vy:word;xms:xfiletype;start:longint);
var qqq,i,l,x,y,lx,ly,nac:word;buffer:array[1..2048] of byte;q:longint;
begin
 xseek(xms,start);q:=0;lx:=0;ly:=0;
 xread(xms,@x,2);xread(xms,@y,2);q:=0;
 repeat
   nac:=SizeOf(Buffer);
   if q+nac>x*y then nac:=(x*y)-q;
   XRead(xms, @Buffer, SizeOf(Buffer));
   q:=q+nac;
   for i:=1 to nac do
   begin
    lx:=lx+1;
    if lx>=x then begin
                   lx:=0;
                   ly:=ly+1;
                  end;
    if buffer[i]<>0 then putpixel(lx+vx,ly+vy,buffer[i]);
  end;
 until q>=x*y;
end;
procedure xputpicturecut(vx,vy,x1,y1,x2,y2:word;xms:xfiletype);
var i,l,x,y,lx,ly,nac:word;buffer:array[0..255] of byte;q,poz:longint;
begin
 xread(xms,@x,2);xread(xms,@y,2);q:=0;
 poz:=xms.pozition;
 repeat
   nac:=SizeOf(Buffer);
   if q+nac>x*y then nac:=(x*y)-q;
   XRead(xms, @Buffer, SizeOf(Buffer));
   q:=q+nac;
   {$I+}
   for i:=1 to l do
   begin
    lx:=lx+1;
    if lx>=x then begin
                   lx:=0;
                   ly:=ly+1;
                  end;
{    if (lx>=x1) and (ly>=y1) and (lx<=x2) and (ly<=y2) then}
        if buffer[i]<>0 then putpixel(lx+vx,ly+vy,buffer[i]);
  end;
 until q>=x*y;
 xms.pozition:=poz;
end;
procedure putpicturecut(vx,vy,zx,zy:word;se:word;off:word);
var xx,xx1,yy,yy1:byte;i,l,x,y:integer;
begin
 xx:=mem[se:off];xx1:=mem[se:off+1];
 yy:=mem[se:off+2];yy1:=mem[se:off+3];
 x:=(xx1*256)+xx;y:=(yy1*256)+yy;
 if zy>y then zy:=y;
 if zx>x then zx:=x;
 for l:=zx to zy-1 do
 for i:=zx+1 to zx do
 begin
  if mem[se:off+3+(l*x)+i]<>0 then
  putpixel(i+vx,l+vy,mem[se:off+3+(l*(x-zx))+(i-zy)]);
 end;
end;
procedure putresizedCUT(x,y,newxsize,newysize,se,off:word);
var xsize,ysize:word;var r:registers;
begin
 r.BX:=off;
 xsize:=memw[se:off];
 ysize:=memw[se:off+2];
 off:=off+4;
 r.AX:=y*maxx+x;
 r.SI:=r.AX;
 y:=0;
 repeat
    r.CX:=1;
    r.DI:=r.SI;
    repeat
        r.CX:=r.CX-1;
        r.AX:=r.CX*xsize;
        r.ax:=r.ax div newxsize;
        r.BX:=r.AX;
        r.AX:=y*ysize;
        r.ax:=r.ax div newysize;
        r.AX:=r.AX*xsize + r.BX + off;
        r.BX:=r.AX;
        if mem[se:r.BX]<>0 then putpixel(r.DI mod maxx,r.DI div maxx,mem[se:r.BX]);
        r.DI:=r.DI+1;
        r.CX:=r.CX+1;
        r.CX:=r.CX+1;
    until (r.CX>=newxsize);
    r.SI:=r.SI+maxx;
    y:=y+1;
 until (y>=newysize);
end;
procedure UserText(x,y:word;s:string;c:byte;zn:fonttype);
var z,b,bit,i:byte;Fh,Fw:byte;
    data:CharType;
begin
 fh:=16;fw:=8;
 for i:=1 to Length(s) do
 begin
  data:=zn[ord(s[i])];
  for z:=0 to fh-1 do
   begin
    b:=data[z];
    for bit:=0 to fw-1 do
     if b and FontMask[bit]<>0
      then if c<>0 then PutPixel(x+bit,y+z,c);
   end;
  if TextOrientation=horizontal
   then inc(x,fw)
   else inc(y,fh);
 end;
end;
procedure OutText(x,y:word;s:string;c:byte;p:pointer);
var z,b,bit,i:byte;Fh,Fw:byte;ii,ll:integer;
    data:CharType;zn:fonttype;
begin
 for ii:=0 to 255 do for ll:=1 to 16 do zn[ii,ll]:=mem[seg(p^):ofs(p^)+(ii*16)+ll];
 fh:=16;fw:=8;
 for i:=1 to Length(s) do
 begin
  data:=zn[ord(s[i])];
  for z:=0 to fh-1 do
   begin
    b:=data[z];
    for bit:=0 to fw-1 do
     if b and FontMask[bit]<>0
      then {if c<>0 then} PutPixel(x+bit,y+z,c);
   end;
  if TextOrientation=horizontal
   then inc(x,fw)
   else inc(y,fh);
 end;
end;
procedure OutText8x16(x,y:word;s:string;c:byte);
var z,b,bit,i:byte;Fh,Fw:byte;ii,ll:integer;
    data:CharType;zn:fonttype;
begin
 for ii:=0 to 255 do for ll:=1 to 16 do zn[ii,ll]:=mem[seg(normal):ofs(normal)+(ii*16)+ll];
 fh:=16;fw:=8;
 for i:=1 to Length(s) do
 begin
  data:=zn[ord(s[i])];
  for z:=0 to fh-1 do
   begin
    b:=data[z];
    for bit:=0 to fw-1 do
     if b and FontMask[bit]<>0
      then {if c<>0 then} PutPixel(x+bit,y+z,c);
   end;
  if TextOrientation=horizontal
   then inc(x,fw)
   else inc(y,fh);
 end;
end;
procedure OutText8x8(x,y:word;s:string;c:byte);
var z,b,bit,i:byte;Fh,Fw:byte;ii,ll:integer;
    data:Char8x8Type;zn:font8x8type;
begin
 for ii:=0 to 255 do for ll:=1 to 8 do zn[ii,ll]:=mem[seg(font8x8):ofs(font8x8)+(ii*8)+ll];
 fh:=8;fw:=8;
 for i:=1 to Length(s) do
 begin
  data:=zn[ord(s[i])];
  for z:=0 to fh-1 do
   begin
    b:=data[z];
    for bit:=0 to fw-1 do
     if b and FontMask[bit]<>0
      then if c<>0 then PutPixel(x+bit,y+z,c);
   end;
  if TextOrientation=horizontal
   then inc(x,fw)
   else inc(y,fh);
 end;
end;
procedure OutText6x6(x,y:word;s:string;c:byte);
var z,b,bit,i:byte;Fh,Fw:byte;
    data:Font6x6char;
begin
 fh:=6;fw:=6;
 for i:=1 to Length(s) do
 begin
  data:=Font6x6Data[ord(s[i])];
  for z:=0 to fh-1 do
   begin
    b:=data[z];
    for bit:=0 to fw-1 do
     if b and FontMask[bit]<>0
      then if c<>0 then PutPixel(x+bit,y+z,c);
   end;
  if TextOrientation=horizontal
   then inc(x,fw)
   else inc(y,fh);
 end;
end;
procedure fill(x,y:word;c:byte);
var stc:byte;
procedure fillx(x,y:word);
begin
 putpixel(x,y,c);
 if x>0 then if getpixel(x-1,y)=stc then fillx(x-1,y);
 if y>0 then if getpixel(x,y-1)=stc then fillx(x,y-1);
 if x<maxx then if getpixel(x+1,y)=stc then fillx(x+1,y);
 if y<maxy then if getpixel(x,y+1)=stc then fillx(x,y+1);
end;
begin
 stc:=getpixel(x,y);
 fillx(x,y);
end;
function getmaxx:word;
begin
 getmaxx:=maxx;
end;
function getmaxy:word;
begin
 getmaxy:=maxy;
end;
procedure setviewport(x1,y1,x2,y2:word);
begin
 if (x1>=0) then vx1:=x1;if (y1>=0) then vy1:=y1;
 if (x2<=maxx) then vx2:=x2;if (y2<=maxy) then vy2:=y2;
end;
procedure volani_mysky ( sluzba : byte; var par1, par2, par3, par4 : word );
var  r : registers;
begin
 r.ax:=sluzba; r.bx:=par2;
 r.cx:=par3; r.dx:=par4;
 intr(51,r);
 par1:=r.ax; par2:=r.bx;
 par3:=r.cx; par4:=r.dx;
end;
procedure showmouse;
var r:registers;
begin
{  r.ax:=1;
  intr($33,r);}
  showm:=true;
end;
procedure hidemouse;
var r:registers;
begin
{  r.ax:=2;
  intr($33,r);}
  showm:=false;
end;
procedure setmouse(x,y:word);
var r:registers;d:word;
begin
 volani_mysky(4,d,d,x,y);
end;
procedure setnewmcurzor(hsx,hsy:word; var c );
var r : registers;i,l:integer;
begin
{ r.ax:=9;
 r.bx:=word(hsx);r.cx:=word(hsy);
 r.dx:=ofs(c);r.es:=seg(c);
 intr($33,r);}
 mct256:=false;
 for i:=0 to 1 do for l:=0 to 15 do curzm[i,l]:=memw[seg(c):ofs(c)+((i*16)+l)*2];
 mco:=true;
end;
procedure setnewmcurzor256(hsx,hsy:word;var c);
var r : registers;i,l:integer;
begin
{ r.ax:=9;
 r.bx:=word(hsx);r.cx:=word(hsy);
 r.dx:=ofs(c);r.es:=seg(c);
 intr($33,r);}
 mct256:=true;
 for i:=0 to 15 do for l:=0 to 15 do curzm256[i,l]:=mem[seg(c):ofs(c)+(i*16)+l];
 mco:=true;
end;
procedure setmcurzor(ktery:byte);
begin
 case ktery of
      1:setnewmcurzor(x_sipka,y_sipka,k_sipka);
      2:setnewmcurzor(x_kriz,y_kriz,k_kriz);
      3:setnewmcurzor(x_xkriz,y_xkriz,k_xkriz);
      4:setnewmcurzor(x_hodinky,y_hodinky,k_hodinky);
      5:setnewmcurzor(x_hodinky,y_hodinky,k_ihodinky);
      6:setnewmcurzor(x_presipacky,y_presipacky,k_presipacky);
      7:setnewmcurzor(x_otaznik,y_otaznik,k_otaznik);
      8:setnewmcurzor(x_ruka,y_ruka,k_ruka);
      9:setnewmcurzor(x_ok,y_ok,k_ok);
     10:setnewmcurzor(x_no,y_no,k_no);
     11:setnewmcurzor(x_sipkaSZxJV,y_sipkaSZxJV,k_sipkaSZxJV);
     12:setnewmcurzor(x_sipkaSxJ,y_sipkaSxJ,k_sipkaSxJ);
     13:setnewmcurzor(x_sipkaSVxJZ,y_sipkaSVxJZ,k_sipkaSVxJZ);
     14:setnewmcurzor(x_sipkaVxZ,y_sipkaVxZ,k_sipkaVxZ);
     15:setnewmcurzor(x_sipkaZ,y_sipkaZ,k_sipkaZ);
     16:setnewmcurzor(x_sipkaS,y_sipkaS,k_sipkaS);
     17:setnewmcurzor(x_sipkaV,y_sipkaV,k_sipkaV);
     18:setnewmcurzor(x_sipkaJ,y_sipkaJ,k_sipkaJ);
     19:setnewmcurzor(x_textkurzor,y_textkurzor,k_textkurzor);
     20:setnewmcurzor(x_zamerovac,y_zamerovac,k_zamerovac);
 end;
end;
procedure mousestatus(var x,y:word;var tl1,tl2,tl3:boolean );
var d,tl:word;r:registers;
begin
 volani_mysky(3,d,tl,x,y);
 tl1:=odd(tl); tl2:=odd(tl shr 1); tl3:=odd(tl shr 2);
end;
procedure redrawmouse;
begin
 mco:=true;
end;
procedure mousepoz(var x,y:word);
var d,tl:word;r:registers;
begin
 volani_mysky(3,d,tl,x,y);
end;
procedure setmouseminmax(mnx,mxx,mny,mxy:word);
var r:registers;
begin
 r.ax:=$0007;
 r.cx:=mnx;
 r.dx:=mxx;
 intr($33,r);
 r.ax:=$0008;
 r.cx:=mny;
 r.dx:=mxy;
 intr($33,r);
end;
procedure setmousesinsitive(x,y:word);
var r:registers;
begin
 r.ax:=$000F;
 r.cx:=x;
 r.dx:=y;
 intr($33,r);
end;
procedure getrelmouse(var x,y:integer);
var r:registers;
begin
 r.ax:=$000B;
 intr($33,r);
 x:=r.cx;
 y:=r.dx;
end;
procedure setmouseevent(mask:byte;se,off:word);
var r:registers;
begin
 r.ax:=$000C;
 r.cx:=mask;
 r.es:=se;
 r.dx:=off;
 intr($33,r);
end;
procedure joystickAinfo(var x,y:word;var tl1,tl2:boolean);
var r:registers;
begin
 r.ah:=$84;
 r.dx:=1;
 intr($15,r);
 x:=r.ax;
 y:=r.bx;
 r.ah:=$84;
 r.dx:=0;
 intr($15,r);
 tl1:=(r.al and 16)=1;
 tl2:=(r.al and 32)=1;
end;
procedure joystickBinfo(var x,y:word;var tl1,tl2:boolean);
var r:registers;
begin
 r.ah:=$84;
 r.dx:=1;
 intr($15,r);
 x:=r.cx;
 y:=r.dx;
 r.ah:=$84;
 r.dx:=0;
 intr($15,r);
 tl1:=(r.al and 64)=1;
 tl2:=(r.al and 128)=1;
end;
function XMSerrmesage(err:byte):string;
begin
 case err of
  0  :XMSerrmesage:='Vsechno OK';
  1  :XMSerrmesage:='Neni pamet XMS';
  $80:XMSerrmesage:='Funkce XMS neni implementovana';
  $81:XMSerrmesage:='Zisteno zarizeni VDISK';
  $82:XMSerrmesage:='Nastala chyba A20';
  $8E:XMSerrmesage:='Obecna chyba ovladace XMS';
  $8F:XMSerrmesage:='Nezotavitelna chyba ovladace XMS';
  $90:XMSerrmesage:='Pamet HMA neexistuje';
  $91:XMSerrmesage:='Pamet HMA je jiz pouzivana';
  $91:XMSerrmesage:='Nevyhovuje parametr /HMAMIN=';
  $93:XMSerrmesage:='Pamet HMA neni pridelena';
  $94:XMSerrmesage:='Hardvare A20 je dosud zapnuto';
  $A0:XMSerrmesage:='Vsechna rozsirena pamet je alokovana';
  $A1:XMSerrmesage:='Vsechny rukojeti rozsirene pameti jsou pozivany';
  $A2:XMSerrmesage:='Rukojet je neplatna';
  $A3:XMSerrmesage:='Zdrojova rukojet je neplatna';
  $A4:XMSerrmesage:='Zdrojovy offset je neplatny';
  $A5:XMSerrmesage:='Cilova rukojet je neplatna';
  $A6:XMSerrmesage:='Cilovy offset je neplatny';
  $A7:XMSerrmesage:='Delka je neplatna';
  $A8:XMSerrmesage:='Presouvane oblasti maji nepovoleny presah';
  $A9:XMSerrmesage:='Nastala chyba parity';
  $AA:XMSerrmesage:='Blok neni uzamcen';
  $AB:XMSerrmesage:='Blok je uzamcen';
  $AC:XMSerrmesage:='Precteni maximalniho poctu zamku bloku';
  $AD:XMSerrmesage:='Uzamceni neuspesne';
  $B0:XMSerrmesage:='K dispozici je mensi blok UMB';
  $B1:XMSerrmesage:='Nejsou dalsi bloky horni pameti';
  $B2:XMSerrmesage:='Cislo segmentu UMB je neplatne';
 end;
end;
function testXMS:boolean;
var r:registers;
begin
 r.ah:=$43;
 r.al:=$00;
 intr($2F,r);
 if r.al=$80 then testXMS:=true else testXMS:=false;
 if r.al<>$80 then exit else
 begin
  r.AX:=$4310;
  intr($2F,r);
  XMSaddr:=longint(r.es) shl 16 + r.bx;
 end;
 XMSerror:=0;
end;
function XMSver:word;
var r:registers;
begin
 r.AX:=$4300;
 intr($2F,r);
 if r.al<>$80 then exit else
 begin
  r.AX:=$4310;
  intr($2F,r);
  XMSaddr:=longint(r.es) shl 16 + r.bx;
  r.ax:=0;
  longcall(XMSaddr, r);
  XMSver:=r.ax;
 end;
end;
procedure allocHMA(size:word);
var r:registers;
begin
 r.ah:=01;
 r.dx:=size;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure deallocHMA;
var r:registers;
begin
 r.ah:=02;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure GlobEnableA20;
var r:registers;
begin
 r.ah:=03;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure GlobDisableA20;
var r:registers;
begin
 r.ah:=03;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure LocalEnableA20;
var r:registers;
begin
 r.ah:=05;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure LocalDisableA20;
var r:registers;
begin
 r.ah:=06;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
function getA20status:boolean;
var r:registers;
begin
 r.ah:=07;
 longcall(XMSaddr, r);
 if r.ax=$0001 then getA20status:=true else getA20status:=false;
 XMSerror:=r.bl;
end;
function XMSmaxblock:word;
var r:registers;
begin
 r.ah:=08;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSmaxblock:=r.ax;
end;
function XMSfree:word;
var r:registers;
begin
 r.ah:=08;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSfree:=r.dx;
end;
function allocXMS(size:word):word;
var r:registers;
begin
 r.ah:=09;
 r.dx:=size;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 allocXMS:=r.dx;
end;
procedure deallocXMS(handle:word);
var r:registers;
begin
 r.ah:=$0A;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure moveXMS(SHandle,SSeg,SOfs,DHandle,DSeg,DOfs:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=SSeg;Sof:=SOfs;Dha:=Dhandle;Dse:=DSeg;Dof:=Dofs;
 end;

 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure basetoXMS(SSeg,SOfs,DHandle:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=0;Sse:=SSeg;Sof:=SOfs;Dha:=Dhandle;Dse:=0;Dof:=0;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure XMStoXMS(SHandle,DHandle:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=0;Sof:=0;Dha:=DHandle;Dse:=0;Dof:=0;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure XMStoBase(SHandle,DSeg,DOfs:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=0;Sof:=0;Dha:=0;Dse:=Dseg;Dof:=Dofs;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure lockXMS(handle:word);
var r:registers;
begin
 r.ah:=$0C;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 r.dx:=XMSinfo.blockseg;
 r.bx:=XMSinfo.blockofs;
end;
procedure unLockXMS(handle:word);
var r:registers;
begin
 r.ah:=$0D;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure XMSblockinfo(handle:word);
var r:registers;
begin
 r.ah:=$0E;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSinfo.locks:=r.bh;
 XMSinfo.freehandle:=r.bl;
 XMSinfo.length:=r.dx;
end;
procedure reallocXMS(handle,length:word);
var r:registers;
begin
 r.ah:=$0F;
 r.dx:=handle;
 r.bx:=length;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure allocUMB(size:word);
var r:registers;
begin
 r.ah:=$10;
 r.dx:=size;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSinfo.blockseg:=r.bx;
 XMSinfo.length:=r.dx;
end;
procedure deallocUMB(blockseg:word);
var r:registers;
begin
 r.ah:=$11;
 r.dx:=blockseg;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
function UMBmaxblock:word;
var r:registers;
begin
 r.ah:=$10;
 r.dx:=$FFFF;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 UMBmaxblock:=r.dx;
end;
function readkey:char;
var r:registers;
begin
 r.ah:=0;
 intr($16,r);
 readkey:=chr(r.al);
end;
function  keypressed:boolean;
var r  : registers;
begin
  r.ah := $11;
  intr($16,r);
  KEYPRESSED := (R.FLAGS AND FZERO) = 0;
end;
function  testkey(ch:char):boolean;
begin
 testkey:=false;
 if keypressed then if (ch=readkey) then testkey:=true;
end;
procedure sentkey(ch:char);
begin
 r.ah:=05;
 r.cl:=ord(ch);
 intr($16,r);
end;
procedure playsound(vz,dz:integer);
begin
  sound(vz);
  delay(dz);
  nosound;
end;
function compressfile(s,s1:string):integer;
var fi,fo:file of byte;c1,c2,c3,i,Zbyva:byte;
    l1,l2:longint;
procedure VemZnak;
begin
 c1:=c2;c2:=c3;
 if not Eof(fi) then begin read(fi,c3);inc(l1); end
                else begin  dec(zbyva);c3:=(c2 mod 255)+1;end;
end;
begin
 {$I-}
 assign(fi,s);reset(fi);
 assign(fo,s1);rewrite(fo);
 l1:=0;l2:=0;Zbyva:=2;
 vemznak;vemznak;
 while not eof(fi) do
 begin
  vemznak;
  if ((c1=c2) and (c2=c3)) or ((c1 and $c0)=$c0) then
  begin
   i:=1;
   while (c1=c2) and (i<63) do
   begin
    inc(i);vemznak;
   end;
   i:=i or $c0;write(fo,i,c1);inc(l2);
  end else write(fo,c1);
  inc(l2);
 end;
 if zbyva=2 then write(fo,c2,c3)
 else if zbyva=1 then write(fo,c2);
 inc(l2,Zbyva);
 close(fi);close(fo);
 {$I+}
 if IOresult<>0 then compressfile:=IOresult+100
 else compressfile:=round((l1-l2)/l1*100);
end;
function decompressfile(s,s1:string):integer;
var fi:file of byte;fo:text;i,j,b:byte;
begin
 {$I-}
 assign(fi,s);reset(fi);
 assign(fo,s1);rewrite(fo);
 while not eof(fi) do
 begin
  read(fi,b);
  if (b and $c0)=$c0 then
  begin
   j:=b and $3f;read(fi,b);
   for i:=1 to j do write(fo,char(b));
  end else write(fo,char(b));
 end;
 close(fi);close(fo);
 {$I+}
 if IOresult<>0 then decompressfile:=IOResult
 else decompressfile:=0;
end;
procedure play(Pseg,Pofs,Ple:word);
var i:integer;stup:byte;krizek:byte;f,d:word;
begin
 D:=tdelay[1];krizek:=0;stup:=4;
 for i:=0 to Ple do
 begin
  if (mem[Pseg:Pofs+i]>=14) and (mem[Pseg:Pofs+i]<=19) then
   stup:=mem[Pseg:Pofs+i]-13;
  if (mem[Pseg:Pofs+i]>=20) and (mem[Pseg:Pofs+i]<=23) then
   krizek:=mem[Pseg:Pofs+i]-20;
  if (mem[Pseg:Pofs+i]>=24) and (mem[Pseg:Pofs+i]<=29) then
   d:=tdelay[mem[Pseg:Pofs+i]-23];
  if (mem[Pseg:Pofs+i]>=30) and (mem[Pseg:Pofs+i]<=37) then
  begin
   if krizek=0 then f:=ntfreg[stup,mem[Pseg:Pofs+i]-30];
   if krizek=1 then f:=xtfreg[stup,mem[Pseg:Pofs+i]-30];
   if krizek=2 then f:=btfreg[stup,mem[Pseg:Pofs+i]-30];
  end else f:=0;
 if f>0 then
 begin
  sound(f);
  delay(d);
  nosound;
 end;
 end;
end;
function getSVGAmesage(err:byte):string;
begin
 case err of
  0:getSVGAmesage:='Zadna chyba';
  1:getSVGAmesage:='Nedostatek pameti';
  2:getSVGAmesage:='Neplatne cislo videostranky';
  3:getSVGAmesage:='Program vyzaduje grafickou kartu VGA';
 end;
end;
function geterrormesage(err:byte):string;
begin
 case err of
  0:geterrormesage:='Zadna chyba';
  1:geterrormesage:='Neplatn kd funkce pi voln DOSu';
  2:geterrormesage:='Soubor nebyl nalezen';
  3:geterrormesage:='Nebyla nalezena cesta';
  4:geterrormesage:='Pli mnoho otevench soubor';
  5:geterrormesage:='Soubor nen pstupn';
  6:geterrormesage:='Neplatn ovlada souboru';
 12:geterrormesage:='Neplatn kd pstupu k pamti';
 15:geterrormesage:='Neplatn slo disketov jednotky';
 16:geterrormesage:='Aktuln adres nelze smazat';
 17:geterrormesage:='Pejmenovnm nen mon pesunout soubor na jin disk';
 18:geterrormesage:='Nen dal soubor';
100:geterrormesage:='Chyba ten';
101:geterrormesage:='Chyba zpisu';
102:geterrormesage:='Soubor nebyl piazen';
103:geterrormesage:='Soubor nebyl oteven';
104:geterrormesage:='Soubor nebyl oteven pro vstup';
105:geterrormesage:='Soubor nebyl oteven pro vstup';
106:geterrormesage:='Neplatn formt sla';
150:geterrormesage:='Disk chrnn proti zpisu';
151:geterrormesage:='patn dlka struktury poadavku na disk';
152:geterrormesage:='Disk nen pipraven';
154:geterrormesage:='Chyba CRC v datech';
156:geterrormesage:='Chyba pi hledn sektoru';
157:geterrormesage:='Neznm typ media';
158:geterrormesage:='Nenalezen sektor disku';
159:geterrormesage:='Tiskrna nem papr';
160:geterrormesage:='Chyba pi zpisu do zazen';
161:geterrormesage:='Chyba p ten ze zazen';
162:geterrormesage:='Chyba hardwaru';
200:geterrormesage:='Dlen nulou';
201:geterrormesage:='Chyba rozsahu';
202:geterrormesage:='Peteen zsobnku';
203:geterrormesage:='Peteen haldy';
204:geterrormesage:='Neplatn operace s ukazatelem';
205:geterrormesage:='seln peteen pi operaci s relnmi sly';
206:geterrormesage:='seln podteen pi operaci s relnmi sly';
207:geterrormesage:='Neplatn operace s relnmi sly';
208:geterrormesage:='Nen nainstalovna sprva ovrlej';
209:geterrormesage:='Chyba pi ten souboru overlay';
210:geterrormesage:='Neinicializovan objekt';
211:geterrormesage:='Voln abstraktn metody';
212:geterrormesage:='Chyba registrace proudu';
213:geterrormesage:='Index kolekce mimo rozsah';
214:geterrormesage:='Peplnn kolekce';
215:geterrormesage:='Chyba aritmetickho peteen';
216:geterrormesage:='Chyba obecn ochrany';
 end;
end;
procedure XAssign(var f:XFileType;size:word);
begin
 f.handle:=allocXMS(size);
 f.size:=size;
 f.pozition:=0;
end;
procedure XRead(var f:XFileType;dest:pointer;size:longint);
begin
 if f.handle=0 then
 begin
  XMSerror:=$A2;
  exit;
 end;
 moveXMS(f.handle,f.pozition div 65535,f.pozition mod 65535,0,seg(dest^),ofs(dest^),size);
 f.pozition:=f.pozition+size;
end;
procedure XWrite(var f:XFileType;dest:pointer;size:longint);
begin
 if f.handle=0 then
 begin
  XMSerror:=$A2;
  exit;
 end;
 moveXMS(0,seg(dest^),ofs(dest^),f.handle,f.pozition div 65535,f.pozition mod 65535,size);
 f.pozition:=f.pozition+size;
end;
procedure XSeek(var f:XFileType;poz:longint);
begin
 f.pozition:=poz;
end;
function  XSize(var f:XFileType):longint;
begin
 XSize:=f.size;
end;
function  XPoz(var f:XFileType):longint;
begin
 XPoz:=f.pozition;
end;
procedure XClose(var f:XFileType);
begin
 deallocXMS(f.handle);
end;
{Rutiny pro Sound Blaster}
const SbDefTimeout       = 0;
const DSPResetPortOffset = $06;
const DSPReadPortOffset  = $0A;
const DSPWritePortOffset = $0C;
const DSPRStatPortOffset = $0E;
const MixAddrPortOffset  = $04;
const MixDataPortOffset  = $05;
const sdcGetDSPVersion   = $E1;
const RESETS             = 10;
const RESETTIMES         = 50;
const SbProRegs:array[1..7] of byte = ( $22, $04, $26, $2E, $0A, $00, $28 );
      Sb16Regs :array[1..7] of byte = ( $30, $32, $34, $38, $3A, $3B, $34 );

function SbReadByte:byte;
begin
  delay(SbDefTimeout);
  SbReadByte:=port[Sb_io_port + DSPReadPortOffset];
end;
procedure SbWriteByte(b:byte);
begin
  delay(SbDefTimeout);
  port[Sb_io_port + DSPWritePortOffset]:=b;
end;
function SbReadMixerReg(reg:byte):byte;
begin
  port[Sb_io_port + MixAddrPortOffset]:=reg;
  SbReadMixerReg := port[Sb_io_port + MixDataPortOffset ];
end;
procedure SbWriteMixerReg( reg, val:byte );
begin
  port[Sb_io_port + MixAddrPortOffset]:= reg ;
  port[Sb_io_port + MixDataPortOffset]:= val ;
end;
function SbMixerDetect:boolean;
var savereg, newreg:byte;
begin
  savereg := SbReadMixerReg($22);
  SbWriteMixerReg($22, 243);
  newreg := SbReadMixerReg($22);
  SbWriteMixerReg($22, savereg);
  if (newreg = 243) then Sbmixerdetect:=true
  else Sbmixerdetect:=false;
end;
procedure SbGetDSPVersion;
var sbmaj, sbmin:byte;
begin
  SbWriteByte(sdcGetDSPVersion);
  while (SbReadByte = $aa) do;
  sbmin := SbReadByte;
  sbversion:=(sbmaj shl 8) + sbmin;
  sbprodetected := (Sbmixerdetect) and (sbversion < $400);
  sb16detected := (Sbmixerdetect) and (sbversion >= $400);
end;
function SbDetect:boolean;
var nr_resets, times_reset:byte;
    sbdetected:boolean;
begin
  sbdetected := false;
  Sb_io_port   := $210;
  nr_resets := RESETS;
  while ( (Sb_io_port <= $260) and (not sbdetected) ) do
  begin
    port[Sb_io_port + DSPResetPortOffset]:= 1;
    port[Sb_io_port + DSPResetPortOffset]:= 0;
    times_reset := RESETTIMES;
    while ((times_reset > 0) and (port[Sb_io_port + DSPRStatPortOffset] < 128)) do dec(times_reset);
    if ( (times_reset = 0) or (port[Sb_io_port + DSPReadPortOffset] <> $AA) ) then
    begin
      dec(nr_resets);
      if (nr_resets=0) then
      begin
	nr_resets := RESETS;
	Sb_io_port := Sb_io_port+$10;
      end;
    end
    else
      sbdetected := true;
  end;
  if (sbdetected) then Sbgetdspversion;
  sbdetect:=sbdetected;
end;
procedure SbMixerGetVolume(reg:byte;var VolLeft, VolRight:byte);
var Addrx:byte;
begin

  if (sb16detected) then Addrx := Sb16Regs[reg]
    else Addrx := SbProRegs[reg];

  VolLeft  := 0;
  VolRight := 0;

  if (reg = mvMicrophone) then begin
    if (sb16detected) then VolLeft := SbReadMixerReg(Addrx)
      else VolLeft := SbReadMixerReg(Addrx) shl 5;
    VolRight := VolLeft;
  end
  else if (reg = mvSpeaker) then begin
    if (sb16detected) then VolLeft := SbReadMixerReg(Addrx);
    VolRight := VolLeft;
  end
  else if (sb16detected) then begin
    VolLeft  := SbReadMixerReg(Addrx);
    VolRight := SbReadMixerReg(Addrx + 1);
  end
  else begin
    VolLeft  := SbReadMixerReg(Addrx);
    VolRight := (VolLeft) shl 4;
    VolLeft  := (VolLeft) and ($F0);
  end;
end;
function SbGetIRQ:integer;
var
   blaster:string;
   interupt, ctr :integer;
   i:integer;
begin
   ctr := 0;i:=1;
   blaster := getenv('BLASTER');{ Get the BLASTER environment string }
   if (blaster = '') then Sbgetirq:= 0;
   while ( (upcase(blaster[i]) <> 'I') and (ctr < 15)) do
   begin
     inc(i);
     inc(ctr);
   end;				{ Find the 'I' value }
   inc(i);      		{ Get the number after the I }
   interupt :=ord(blaster[i])-ord('0');
   if (ctr = 15) then
     Sbgetirq:= 0;
   Sbgetirq:= interupt;         	{ Return it as the integererrupt # }
end;

{Zachyceni chyb}
{$F+}
procedure NewExitProc;
begin
 ExitProc:=SaveExitProc;
{ setmouseevent(0,0,0);}
 if InGraph then CloseGraph;
 if IOWarring then if exitcode>0 then
 begin
  Writeln('Behova chyba : ',geterrormesage(exitcode));
 end;
 if XMSWarring then if XMSerror>0 then
 begin
  Writeln('Chyba XMS : ',XMSerrmesage(XMSerror));
 end;
end;
{$F-}
begin
 {SaveExitProc:=ExitProc;}
 {exitproc:=@NewExitProc;}
 if IsVGA=false then SVGAerror:=3;
 AS := PORT[SEGP];
 IOWarring:=true;
 XMSWarring:=false;
 XMSerror:=0;
 InGraph:=false;
 font:=1;
 textorientation:=horizontal;
 writemode:=normalmode;
 ready:=true;
 r.ax:=0;
 intr($33,r);
 curzm:=k_sipka;
 mousepoz(smx,smy);
 mco:=false;
 {$IFDEF shereware}
 {$I-}
  initgraph(mode320x200);
  drawto(1);
  screen(0);
  putpicture(50,40,seg(startpicture),ofs(startpicture));
  outtext(61,141,'Shereware verze! Cekej...',7,@normal);
  outtext(60,140,'Shereware verze! Cekej...',15,@normal);
  bar(2,160,305,180,3);
  rectangle(2,160,305,180,1);
  screen(1);
  for i:=1 to 10 do rectangle(i*30-25,165,25+i*30-25,175,5);
  for i:=1 to 10 do
  begin
   for l:=1 to 10 do
   begin
    bar(i*30-24,166,25+i*30-26,174,l+75);
    delay(100);
   end;
   playsound(100,1);
  end;
  playsound(1000,10);
  readkey;
  drawto(0);screen(0);
  closegraph;
 {$I+}
 {$ENDIF}
end.